/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */
#include <sstream>
#include "AMQP_ClientProxy.h"
#include "qpid/framing/ChannelAdapter.h"
#include "qpid/framing/amqp_types_full.h"

#include "AccessRequestBody.h"
#include "AccessRequestOkBody.h"
#include "BasicAckBody.h"
#include "BasicCancelBody.h"
#include "BasicCancelOkBody.h"
#include "BasicConsumeBody.h"
#include "BasicConsumeOkBody.h"
#include "BasicDeliverBody.h"
#include "BasicGetBody.h"
#include "BasicGetEmptyBody.h"
#include "BasicGetOkBody.h"
#include "BasicPublishBody.h"
#include "BasicQosBody.h"
#include "BasicQosOkBody.h"
#include "BasicRecoverBody.h"
#include "BasicRejectBody.h"
#include "BasicReturnBody.h"
#include "ChannelCloseBody.h"
#include "ChannelCloseOkBody.h"
#include "ChannelFlowBody.h"
#include "ChannelFlowOkBody.h"
#include "ChannelOkBody.h"
#include "ChannelOpenBody.h"
#include "ChannelOpenOkBody.h"
#include "ChannelPingBody.h"
#include "ChannelPongBody.h"
#include "ChannelResumeBody.h"
#include "ConnectionCloseBody.h"
#include "ConnectionCloseOkBody.h"
#include "ConnectionOpenBody.h"
#include "ConnectionOpenOkBody.h"
#include "ConnectionRedirectBody.h"
#include "ConnectionSecureBody.h"
#include "ConnectionSecureOkBody.h"
#include "ConnectionStartBody.h"
#include "ConnectionStartOkBody.h"
#include "ConnectionTuneBody.h"
#include "ConnectionTuneOkBody.h"
#include "DtxSelectBody.h"
#include "DtxSelectOkBody.h"
#include "DtxStartBody.h"
#include "DtxStartOkBody.h"
#include "ExchangeDeclareBody.h"
#include "ExchangeDeclareOkBody.h"
#include "ExchangeDeleteBody.h"
#include "ExchangeDeleteOkBody.h"
#include "FileAckBody.h"
#include "FileCancelBody.h"
#include "FileCancelOkBody.h"
#include "FileConsumeBody.h"
#include "FileConsumeOkBody.h"
#include "FileDeliverBody.h"
#include "FileOpenBody.h"
#include "FileOpenOkBody.h"
#include "FilePublishBody.h"
#include "FileQosBody.h"
#include "FileQosOkBody.h"
#include "FileRejectBody.h"
#include "FileReturnBody.h"
#include "FileStageBody.h"
#include "MessageAppendBody.h"
#include "MessageCancelBody.h"
#include "MessageCheckpointBody.h"
#include "MessageCloseBody.h"
#include "MessageConsumeBody.h"
#include "MessageEmptyBody.h"
#include "MessageGetBody.h"
#include "MessageOffsetBody.h"
#include "MessageOkBody.h"
#include "MessageOpenBody.h"
#include "MessageQosBody.h"
#include "MessageRecoverBody.h"
#include "MessageRejectBody.h"
#include "MessageResumeBody.h"
#include "MessageTransferBody.h"
#include "QueueBindBody.h"
#include "QueueBindOkBody.h"
#include "QueueDeclareBody.h"
#include "QueueDeclareOkBody.h"
#include "QueueDeleteBody.h"
#include "QueueDeleteOkBody.h"
#include "QueuePurgeBody.h"
#include "QueuePurgeOkBody.h"
#include "QueueUnbindBody.h"
#include "QueueUnbindOkBody.h"
#include "StreamCancelBody.h"
#include "StreamCancelOkBody.h"
#include "StreamConsumeBody.h"
#include "StreamConsumeOkBody.h"
#include "StreamDeliverBody.h"
#include "StreamPublishBody.h"
#include "StreamQosBody.h"
#include "StreamQosOkBody.h"
#include "StreamReturnBody.h"
#include "TunnelRequestBody.h"
#include "TxCommitBody.h"
#include "TxCommitOkBody.h"
#include "TxRollbackBody.h"
#include "TxRollbackOkBody.h"
#include "TxSelectBody.h"
#include "TxSelectOkBody.h"

namespace qpid {
namespace framing {


AMQP_ClientProxy::AMQP_ClientProxy(ChannelAdapter& ch) :
    Proxy(ch),
    accessProxy(channel),
    basicProxy(channel),
    channelProxy(channel),
    connectionProxy(channel),
    dtxProxy(channel),
    exchangeProxy(channel),
    fileProxy(channel),
    messageProxy(channel),
    queueProxy(channel),
    streamProxy(channel),
    tunnelProxy(channel),
    txProxy(channel)
    {}

    // Inner class instance get methods
	
AMQP_ClientProxy::Access& AMQP_ClientProxy::getAccess()
{
    return accessProxy;
}

AMQP_ClientProxy::Basic& AMQP_ClientProxy::getBasic()
{
    return basicProxy;
}

AMQP_ClientProxy::Channel& AMQP_ClientProxy::getChannel()
{
    return channelProxy;
}

AMQP_ClientProxy::Connection& AMQP_ClientProxy::getConnection()
{
    return connectionProxy;
}

AMQP_ClientProxy::Dtx& AMQP_ClientProxy::getDtx()
{
    return dtxProxy;
}

AMQP_ClientProxy::Exchange& AMQP_ClientProxy::getExchange()
{
    return exchangeProxy;
}

AMQP_ClientProxy::File& AMQP_ClientProxy::getFile()
{
    return fileProxy;
}

AMQP_ClientProxy::Message& AMQP_ClientProxy::getMessage()
{
    return messageProxy;
}

AMQP_ClientProxy::Queue& AMQP_ClientProxy::getQueue()
{
    return queueProxy;
}

AMQP_ClientProxy::Stream& AMQP_ClientProxy::getStream()
{
    return streamProxy;
}

AMQP_ClientProxy::Tunnel& AMQP_ClientProxy::getTunnel()
{
    return tunnelProxy;
}

AMQP_ClientProxy::Tx& AMQP_ClientProxy::getTx()
{
    return txProxy;
}

    // Inner class implementation

// ==================== class Access ====================
void AMQP_ClientProxy::Access::requestOk(u_int16_t ticket, RequestId responseTo)
{
        channel.send(new AccessRequestOkBody( channel.getVersion(), responseTo,
                         ticket));
}


// ==================== class Basic ====================
void AMQP_ClientProxy::Basic::cancelOk(const string& consumerTag, RequestId responseTo)
{
        channel.send(new BasicCancelOkBody( channel.getVersion(), responseTo,
                         consumerTag));
}


void AMQP_ClientProxy::Basic::consumeOk(const string& consumerTag, RequestId responseTo)
{
        channel.send(new BasicConsumeOkBody( channel.getVersion(), responseTo,
                         consumerTag));
}


RequestId AMQP_ClientProxy::Basic::deliver(const string& consumerTag,
                    u_int64_t deliveryTag,
                    bool redelivered,
                    const string& exchange,
                    const string& routingKey)
{
        return channel.send(new BasicDeliverBody( channel.getVersion(),
                         consumerTag,
                         deliveryTag,
                         redelivered,
                         exchange,
                         routingKey));
}


void AMQP_ClientProxy::Basic::getEmpty(const string& clusterId, RequestId responseTo)
{
        channel.send(new BasicGetEmptyBody( channel.getVersion(), responseTo,
                         clusterId));
}


void AMQP_ClientProxy::Basic::getOk(u_int64_t deliveryTag,
                    bool redelivered,
                    const string& exchange,
                    const string& routingKey,
                    u_int32_t messageCount, RequestId responseTo)
{
        channel.send(new BasicGetOkBody( channel.getVersion(), responseTo,
                         deliveryTag,
                         redelivered,
                         exchange,
                         routingKey,
                         messageCount));
}


void AMQP_ClientProxy::Basic::qosOk(RequestId responseTo)
{
        channel.send(new BasicQosOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ClientProxy::Basic::return_(u_int16_t replyCode,
                    const string& replyText,
                    const string& exchange,
                    const string& routingKey)
{
        return channel.send(new BasicReturnBody( channel.getVersion(),
                         replyCode,
                         replyText,
                         exchange,
                         routingKey));
}


// ==================== class Channel ====================
RequestId AMQP_ClientProxy::Channel::close(u_int16_t replyCode,
                    const string& replyText,
                    u_int16_t classId,
                    u_int16_t methodId)
{
        return channel.send(new ChannelCloseBody( channel.getVersion(),
                         replyCode,
                         replyText,
                         classId,
                         methodId));
}


void AMQP_ClientProxy::Channel::closeOk(RequestId responseTo)
{
        channel.send(new ChannelCloseOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ClientProxy::Channel::flow(bool active)
{
        return channel.send(new ChannelFlowBody( channel.getVersion(),
                         active));
}


void AMQP_ClientProxy::Channel::flowOk(bool active, RequestId responseTo)
{
        channel.send(new ChannelFlowOkBody( channel.getVersion(), responseTo,
                         active));
}


void AMQP_ClientProxy::Channel::ok(RequestId responseTo)
{
        channel.send(new ChannelOkBody( channel.getVersion(), responseTo));
}


void AMQP_ClientProxy::Channel::openOk(const string& channelId, RequestId responseTo)
{
        channel.send(new ChannelOpenOkBody( channel.getVersion(), responseTo,
                         channelId));
}


RequestId AMQP_ClientProxy::Channel::ping()
{
        return channel.send(new ChannelPingBody( channel.getVersion()));
}


RequestId AMQP_ClientProxy::Channel::pong()
{
        return channel.send(new ChannelPongBody( channel.getVersion()));
}


// ==================== class Connection ====================
RequestId AMQP_ClientProxy::Connection::close(u_int16_t replyCode,
                    const string& replyText,
                    u_int16_t classId,
                    u_int16_t methodId)
{
        return channel.send(new ConnectionCloseBody( channel.getVersion(),
                         replyCode,
                         replyText,
                         classId,
                         methodId));
}


void AMQP_ClientProxy::Connection::closeOk(RequestId responseTo)
{
        channel.send(new ConnectionCloseOkBody( channel.getVersion(), responseTo));
}


void AMQP_ClientProxy::Connection::openOk(const string& knownHosts, RequestId responseTo)
{
        channel.send(new ConnectionOpenOkBody( channel.getVersion(), responseTo,
                         knownHosts));
}


void AMQP_ClientProxy::Connection::redirect(const string& host,
                    const string& knownHosts, RequestId responseTo)
{
        channel.send(new ConnectionRedirectBody( channel.getVersion(), responseTo,
                         host,
                         knownHosts));
}


RequestId AMQP_ClientProxy::Connection::secure(const string& challenge)
{
        return channel.send(new ConnectionSecureBody( channel.getVersion(),
                         challenge));
}


RequestId AMQP_ClientProxy::Connection::start(u_int8_t versionMajor,
                    u_int8_t versionMinor,
                    const FieldTable& serverProperties,
                    const string& mechanisms,
                    const string& locales)
{
        return channel.send(new ConnectionStartBody( channel.getVersion(),
                         versionMajor,
                         versionMinor,
                         serverProperties,
                         mechanisms,
                         locales));
}


RequestId AMQP_ClientProxy::Connection::tune(u_int16_t channelMax,
                    u_int32_t frameMax,
                    u_int16_t heartbeat)
{
        return channel.send(new ConnectionTuneBody( channel.getVersion(),
                         channelMax,
                         frameMax,
                         heartbeat));
}


// ==================== class Dtx ====================
void AMQP_ClientProxy::Dtx::selectOk(RequestId responseTo)
{
        channel.send(new DtxSelectOkBody( channel.getVersion(), responseTo));
}


void AMQP_ClientProxy::Dtx::startOk(RequestId responseTo)
{
        channel.send(new DtxStartOkBody( channel.getVersion(), responseTo));
}


// ==================== class Exchange ====================
void AMQP_ClientProxy::Exchange::declareOk(RequestId responseTo)
{
        channel.send(new ExchangeDeclareOkBody( channel.getVersion(), responseTo));
}


void AMQP_ClientProxy::Exchange::deleteOk(RequestId responseTo)
{
        channel.send(new ExchangeDeleteOkBody( channel.getVersion(), responseTo));
}


// ==================== class File ====================
void AMQP_ClientProxy::File::cancelOk(const string& consumerTag, RequestId responseTo)
{
        channel.send(new FileCancelOkBody( channel.getVersion(), responseTo,
                         consumerTag));
}


void AMQP_ClientProxy::File::consumeOk(const string& consumerTag, RequestId responseTo)
{
        channel.send(new FileConsumeOkBody( channel.getVersion(), responseTo,
                         consumerTag));
}


RequestId AMQP_ClientProxy::File::deliver(const string& consumerTag,
                    u_int64_t deliveryTag,
                    bool redelivered,
                    const string& exchange,
                    const string& routingKey,
                    const string& identifier)
{
        return channel.send(new FileDeliverBody( channel.getVersion(),
                         consumerTag,
                         deliveryTag,
                         redelivered,
                         exchange,
                         routingKey,
                         identifier));
}


RequestId AMQP_ClientProxy::File::open(const string& identifier,
                    u_int64_t contentSize)
{
        return channel.send(new FileOpenBody( channel.getVersion(),
                         identifier,
                         contentSize));
}


void AMQP_ClientProxy::File::openOk(u_int64_t stagedSize, RequestId responseTo)
{
        channel.send(new FileOpenOkBody( channel.getVersion(), responseTo,
                         stagedSize));
}


void AMQP_ClientProxy::File::qosOk(RequestId responseTo)
{
        channel.send(new FileQosOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ClientProxy::File::return_(u_int16_t replyCode,
                    const string& replyText,
                    const string& exchange,
                    const string& routingKey)
{
        return channel.send(new FileReturnBody( channel.getVersion(),
                         replyCode,
                         replyText,
                         exchange,
                         routingKey));
}


void AMQP_ClientProxy::File::stage(RequestId responseTo)
{
        channel.send(new FileStageBody( channel.getVersion(), responseTo));
}


// ==================== class Message ====================
RequestId AMQP_ClientProxy::Message::append(const string& reference,
                    const string& bytes)
{
        return channel.send(new MessageAppendBody( channel.getVersion(),
                         reference,
                         bytes));
}


RequestId AMQP_ClientProxy::Message::checkpoint(const string& reference,
                    const string& identifier)
{
        return channel.send(new MessageCheckpointBody( channel.getVersion(),
                         reference,
                         identifier));
}


RequestId AMQP_ClientProxy::Message::close(const string& reference)
{
        return channel.send(new MessageCloseBody( channel.getVersion(),
                         reference));
}


void AMQP_ClientProxy::Message::empty(RequestId responseTo)
{
        channel.send(new MessageEmptyBody( channel.getVersion(), responseTo));
}


void AMQP_ClientProxy::Message::offset(u_int64_t value, RequestId responseTo)
{
        channel.send(new MessageOffsetBody( channel.getVersion(), responseTo,
                         value));
}


void AMQP_ClientProxy::Message::ok(RequestId responseTo)
{
        channel.send(new MessageOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ClientProxy::Message::open(const string& reference)
{
        return channel.send(new MessageOpenBody( channel.getVersion(),
                         reference));
}


void AMQP_ClientProxy::Message::reject(u_int16_t code,
                    const string& text, RequestId responseTo)
{
        channel.send(new MessageRejectBody( channel.getVersion(), responseTo,
                         code,
                         text));
}


RequestId AMQP_ClientProxy::Message::resume(const string& reference,
                    const string& identifier)
{
        return channel.send(new MessageResumeBody( channel.getVersion(),
                         reference,
                         identifier));
}


RequestId AMQP_ClientProxy::Message::transfer(u_int16_t ticket,
                    const string& destination,
                    bool redelivered,
                    bool immediate,
                    u_int64_t ttl,
                    u_int8_t priority,
                    u_int64_t timestamp,
                    u_int8_t deliveryMode,
                    u_int64_t expiration,
                    const string& exchange,
                    const string& routingKey,
                    const string& messageId,
                    const string& correlationId,
                    const string& replyTo,
                    const string& contentType,
                    const string& contentEncoding,
                    const string& userId,
                    const string& appId,
                    const string& transactionId,
                    const string& securityToken,
                    const FieldTable& applicationHeaders,
                    const Content& body,
                    bool mandatory)
{
        return channel.send(new MessageTransferBody( channel.getVersion(),
                         ticket,
                         destination,
                         redelivered,
                         immediate,
                         ttl,
                         priority,
                         timestamp,
                         deliveryMode,
                         expiration,
                         exchange,
                         routingKey,
                         messageId,
                         correlationId,
                         replyTo,
                         contentType,
                         contentEncoding,
                         userId,
                         appId,
                         transactionId,
                         securityToken,
                         applicationHeaders,
                         body,
                         mandatory));
}


// ==================== class Queue ====================
void AMQP_ClientProxy::Queue::bindOk(RequestId responseTo)
{
        channel.send(new QueueBindOkBody( channel.getVersion(), responseTo));
}


void AMQP_ClientProxy::Queue::declareOk(const string& queue,
                    u_int32_t messageCount,
                    u_int32_t consumerCount, RequestId responseTo)
{
        channel.send(new QueueDeclareOkBody( channel.getVersion(), responseTo,
                         queue,
                         messageCount,
                         consumerCount));
}


void AMQP_ClientProxy::Queue::deleteOk(u_int32_t messageCount, RequestId responseTo)
{
        channel.send(new QueueDeleteOkBody( channel.getVersion(), responseTo,
                         messageCount));
}


void AMQP_ClientProxy::Queue::purgeOk(u_int32_t messageCount, RequestId responseTo)
{
        channel.send(new QueuePurgeOkBody( channel.getVersion(), responseTo,
                         messageCount));
}


void AMQP_ClientProxy::Queue::unbindOk(RequestId responseTo)
{
        channel.send(new QueueUnbindOkBody( channel.getVersion(), responseTo));
}


// ==================== class Stream ====================
void AMQP_ClientProxy::Stream::cancelOk(const string& consumerTag, RequestId responseTo)
{
        channel.send(new StreamCancelOkBody( channel.getVersion(), responseTo,
                         consumerTag));
}


void AMQP_ClientProxy::Stream::consumeOk(const string& consumerTag, RequestId responseTo)
{
        channel.send(new StreamConsumeOkBody( channel.getVersion(), responseTo,
                         consumerTag));
}


RequestId AMQP_ClientProxy::Stream::deliver(const string& consumerTag,
                    u_int64_t deliveryTag,
                    const string& exchange,
                    const string& queue)
{
        return channel.send(new StreamDeliverBody( channel.getVersion(),
                         consumerTag,
                         deliveryTag,
                         exchange,
                         queue));
}


void AMQP_ClientProxy::Stream::qosOk(RequestId responseTo)
{
        channel.send(new StreamQosOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ClientProxy::Stream::return_(u_int16_t replyCode,
                    const string& replyText,
                    const string& exchange,
                    const string& routingKey)
{
        return channel.send(new StreamReturnBody( channel.getVersion(),
                         replyCode,
                         replyText,
                         exchange,
                         routingKey));
}


// ==================== class Tunnel ====================

// ==================== class Tx ====================
void AMQP_ClientProxy::Tx::commitOk(RequestId responseTo)
{
        channel.send(new TxCommitOkBody( channel.getVersion(), responseTo));
}


void AMQP_ClientProxy::Tx::rollbackOk(RequestId responseTo)
{
        channel.send(new TxRollbackOkBody( channel.getVersion(), responseTo));
}


void AMQP_ClientProxy::Tx::selectOk(RequestId responseTo)
{
        channel.send(new TxSelectOkBody( channel.getVersion(), responseTo));
}


}} // namespae qpid::framing 

