/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_AMQP_ClientProxy__
#define qpid_framing_AMQP_ClientProxy__

#include "qpid/framing/Proxy.h"

namespace qpid {
namespace framing {

class AMQP_ClientProxy : public Proxy
{
public:
    AMQP_ClientProxy(ChannelAdapter& ch);

    // Inner class definitions

    // ==================== class Access ====================
    class Access
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Access(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Access() {}

        static Access& get(AMQP_ClientProxy& proxy) { return proxy.getAccess();}

        // Protocol methods

        virtual void requestOk(u_int16_t ticket, 
                            	RequestId responseTo );
    }; // class Access

    // ==================== class Basic ====================
    class Basic
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Basic(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Basic() {}

        static Basic& get(AMQP_ClientProxy& proxy) { return proxy.getBasic();}

        // Protocol methods

        virtual void cancelOk(const string& consumerTag, 
                            	RequestId responseTo );

        virtual void consumeOk(const string& consumerTag, 
                            	RequestId responseTo );

        virtual RequestId deliver(const string& consumerTag,
                            u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey );

        virtual void getEmpty(const string& clusterId, 
                            	RequestId responseTo );

        virtual void getOk(u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey,
                            u_int32_t messageCount, 
                            	RequestId responseTo );

        virtual void qosOk(	RequestId responseTo );

        virtual RequestId return_(u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey );
    }; // class Basic

    // ==================== class Channel ====================
    class Channel
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Channel(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Channel() {}

        static Channel& get(AMQP_ClientProxy& proxy) { return proxy.getChannel();}

        // Protocol methods

        virtual RequestId close(u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId );

        virtual void closeOk(	RequestId responseTo );

        virtual RequestId flow(bool active );

        virtual void flowOk(bool active, 
                            	RequestId responseTo );

        virtual void ok(	RequestId responseTo );

        virtual void openOk(const string& channelId, 
                            	RequestId responseTo );

        virtual RequestId ping( );

        virtual RequestId pong( );
    }; // class Channel

    // ==================== class Connection ====================
    class Connection
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Connection(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Connection() {}

        static Connection& get(AMQP_ClientProxy& proxy) { return proxy.getConnection();}

        // Protocol methods

        virtual RequestId close(u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId );

        virtual void closeOk(	RequestId responseTo );

        virtual void openOk(const string& knownHosts, 
                            	RequestId responseTo );

        virtual void redirect(const string& host,
                            const string& knownHosts, 
                            	RequestId responseTo );

        virtual RequestId secure(const string& challenge );

        virtual RequestId start(u_int8_t versionMajor,
                            u_int8_t versionMinor,
                            const FieldTable& serverProperties,
                            const string& mechanisms,
                            const string& locales );

        virtual RequestId tune(u_int16_t channelMax,
                            u_int32_t frameMax,
                            u_int16_t heartbeat );
    }; // class Connection

    // ==================== class Dtx ====================
    class Dtx
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Dtx(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Dtx() {}

        static Dtx& get(AMQP_ClientProxy& proxy) { return proxy.getDtx();}

        // Protocol methods

        virtual void selectOk(	RequestId responseTo );

        virtual void startOk(	RequestId responseTo );
    }; // class Dtx

    // ==================== class Exchange ====================
    class Exchange
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Exchange(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Exchange() {}

        static Exchange& get(AMQP_ClientProxy& proxy) { return proxy.getExchange();}

        // Protocol methods

        virtual void declareOk(	RequestId responseTo );

        virtual void deleteOk(	RequestId responseTo );
    }; // class Exchange

    // ==================== class File ====================
    class File
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        File(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~File() {}

        static File& get(AMQP_ClientProxy& proxy) { return proxy.getFile();}

        // Protocol methods

        virtual void cancelOk(const string& consumerTag, 
                            	RequestId responseTo );

        virtual void consumeOk(const string& consumerTag, 
                            	RequestId responseTo );

        virtual RequestId deliver(const string& consumerTag,
                            u_int64_t deliveryTag,
                            bool redelivered,
                            const string& exchange,
                            const string& routingKey,
                            const string& identifier );

        virtual RequestId open(const string& identifier,
                            u_int64_t contentSize );

        virtual void openOk(u_int64_t stagedSize, 
                            	RequestId responseTo );

        virtual void qosOk(	RequestId responseTo );

        virtual RequestId return_(u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey );

        virtual void stage(	RequestId responseTo );
    }; // class File

    // ==================== class Message ====================
    class Message
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Message(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Message() {}

        static Message& get(AMQP_ClientProxy& proxy) { return proxy.getMessage();}

        // Protocol methods

        virtual RequestId append(const string& reference,
                            const string& bytes );

        virtual RequestId checkpoint(const string& reference,
                            const string& identifier );

        virtual RequestId close(const string& reference );

        virtual void empty(	RequestId responseTo );

        virtual void offset(u_int64_t value, 
                            	RequestId responseTo );

        virtual void ok(	RequestId responseTo );

        virtual RequestId open(const string& reference );

        virtual void reject(u_int16_t code,
                            const string& text, 
                            	RequestId responseTo );

        virtual RequestId resume(const string& reference,
                            const string& identifier );

        virtual RequestId transfer(u_int16_t ticket,
                            const string& destination,
                            bool redelivered,
                            bool immediate,
                            u_int64_t ttl,
                            u_int8_t priority,
                            u_int64_t timestamp,
                            u_int8_t deliveryMode,
                            u_int64_t expiration,
                            const string& exchange,
                            const string& routingKey,
                            const string& messageId,
                            const string& correlationId,
                            const string& replyTo,
                            const string& contentType,
                            const string& contentEncoding,
                            const string& userId,
                            const string& appId,
                            const string& transactionId,
                            const string& securityToken,
                            const FieldTable& applicationHeaders,
                            const Content& body,
                            bool mandatory );
    }; // class Message

    // ==================== class Queue ====================
    class Queue
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Queue(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Queue() {}

        static Queue& get(AMQP_ClientProxy& proxy) { return proxy.getQueue();}

        // Protocol methods

        virtual void bindOk(	RequestId responseTo );

        virtual void declareOk(const string& queue,
                            u_int32_t messageCount,
                            u_int32_t consumerCount, 
                            	RequestId responseTo );

        virtual void deleteOk(u_int32_t messageCount, 
                            	RequestId responseTo );

        virtual void purgeOk(u_int32_t messageCount, 
                            	RequestId responseTo );

        virtual void unbindOk(	RequestId responseTo );
    }; // class Queue

    // ==================== class Stream ====================
    class Stream
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Stream(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Stream() {}

        static Stream& get(AMQP_ClientProxy& proxy) { return proxy.getStream();}

        // Protocol methods

        virtual void cancelOk(const string& consumerTag, 
                            	RequestId responseTo );

        virtual void consumeOk(const string& consumerTag, 
                            	RequestId responseTo );

        virtual RequestId deliver(const string& consumerTag,
                            u_int64_t deliveryTag,
                            const string& exchange,
                            const string& queue );

        virtual void qosOk(	RequestId responseTo );

        virtual RequestId return_(u_int16_t replyCode,
                            const string& replyText,
                            const string& exchange,
                            const string& routingKey );
    }; // class Stream

    // ==================== class Tunnel ====================
    class Tunnel
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Tunnel(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Tunnel() {}

        static Tunnel& get(AMQP_ClientProxy& proxy) { return proxy.getTunnel();}

        // Protocol methods

    }; // class Tunnel

    // ==================== class Tx ====================
    class Tx
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Tx(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Tx() {}

        static Tx& get(AMQP_ClientProxy& proxy) { return proxy.getTx();}

        // Protocol methods

        virtual void commitOk(	RequestId responseTo );

        virtual void rollbackOk(	RequestId responseTo );

        virtual void selectOk(	RequestId responseTo );
    }; // class Tx

    // Inner class instance get methods
	
    Access& getAccess();
    Basic& getBasic();
    Channel& getChannel();
    Connection& getConnection();
    Dtx& getDtx();
    Exchange& getExchange();
    File& getFile();
    Message& getMessage();
    Queue& getQueue();
    Stream& getStream();
    Tunnel& getTunnel();
    Tx& getTx();
    
private:
    // Inner class instances
	
    Access accessProxy;
    Basic basicProxy;
    Channel channelProxy;
    Connection connectionProxy;
    Dtx dtxProxy;
    Exchange exchangeProxy;
    File fileProxy;
    Message messageProxy;
    Queue queueProxy;
    Stream streamProxy;
    Tunnel tunnelProxy;
    Tx txProxy;
}; /* class AMQP_ClientProxy */

} /* namespace framing */
} /* namespace qpid */

#endif
