/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#include <sstream>
#include "qpid/framing/ProtocolVersionException.h"
#include "AMQP_MethodVersionMap.h"

namespace qpid
{
namespace framing
{

AMQP_MethodVersionMap::AMQP_MethodVersionMap()
{
    insert(std::make_pair(createMapKey(30, 10, 0, 9), &createMethodBodyFn<AccessRequestBody>));
    insert(std::make_pair(createMapKey(30, 11, 0, 9), &createMethodBodyFn<AccessRequestOkBody>));
    insert(std::make_pair(createMapKey(60, 80, 0, 9), &createMethodBodyFn<BasicAckBody>));
    insert(std::make_pair(createMapKey(60, 30, 0, 9), &createMethodBodyFn<BasicCancelBody>));
    insert(std::make_pair(createMapKey(60, 31, 0, 9), &createMethodBodyFn<BasicCancelOkBody>));
    insert(std::make_pair(createMapKey(60, 20, 0, 9), &createMethodBodyFn<BasicConsumeBody>));
    insert(std::make_pair(createMapKey(60, 21, 0, 9), &createMethodBodyFn<BasicConsumeOkBody>));
    insert(std::make_pair(createMapKey(60, 60, 0, 9), &createMethodBodyFn<BasicDeliverBody>));
    insert(std::make_pair(createMapKey(60, 70, 0, 9), &createMethodBodyFn<BasicGetBody>));
    insert(std::make_pair(createMapKey(60, 72, 0, 9), &createMethodBodyFn<BasicGetEmptyBody>));
    insert(std::make_pair(createMapKey(60, 71, 0, 9), &createMethodBodyFn<BasicGetOkBody>));
    insert(std::make_pair(createMapKey(60, 40, 0, 9), &createMethodBodyFn<BasicPublishBody>));
    insert(std::make_pair(createMapKey(60, 10, 0, 9), &createMethodBodyFn<BasicQosBody>));
    insert(std::make_pair(createMapKey(60, 11, 0, 9), &createMethodBodyFn<BasicQosOkBody>));
    insert(std::make_pair(createMapKey(60, 100, 0, 9), &createMethodBodyFn<BasicRecoverBody>));
    insert(std::make_pair(createMapKey(60, 90, 0, 9), &createMethodBodyFn<BasicRejectBody>));
    insert(std::make_pair(createMapKey(60, 50, 0, 9), &createMethodBodyFn<BasicReturnBody>));
    insert(std::make_pair(createMapKey(20, 40, 0, 9), &createMethodBodyFn<ChannelCloseBody>));
    insert(std::make_pair(createMapKey(20, 41, 0, 9), &createMethodBodyFn<ChannelCloseOkBody>));
    insert(std::make_pair(createMapKey(20, 20, 0, 9), &createMethodBodyFn<ChannelFlowBody>));
    insert(std::make_pair(createMapKey(20, 21, 0, 9), &createMethodBodyFn<ChannelFlowOkBody>));
    insert(std::make_pair(createMapKey(20, 80, 0, 9), &createMethodBodyFn<ChannelOkBody>));
    insert(std::make_pair(createMapKey(20, 10, 0, 9), &createMethodBodyFn<ChannelOpenBody>));
    insert(std::make_pair(createMapKey(20, 11, 0, 9), &createMethodBodyFn<ChannelOpenOkBody>));
    insert(std::make_pair(createMapKey(20, 60, 0, 9), &createMethodBodyFn<ChannelPingBody>));
    insert(std::make_pair(createMapKey(20, 70, 0, 9), &createMethodBodyFn<ChannelPongBody>));
    insert(std::make_pair(createMapKey(20, 50, 0, 9), &createMethodBodyFn<ChannelResumeBody>));
    insert(std::make_pair(createMapKey(10, 50, 0, 9), &createMethodBodyFn<ConnectionCloseBody>));
    insert(std::make_pair(createMapKey(10, 51, 0, 9), &createMethodBodyFn<ConnectionCloseOkBody>));
    insert(std::make_pair(createMapKey(10, 40, 0, 9), &createMethodBodyFn<ConnectionOpenBody>));
    insert(std::make_pair(createMapKey(10, 41, 0, 9), &createMethodBodyFn<ConnectionOpenOkBody>));
    insert(std::make_pair(createMapKey(10, 42, 0, 9), &createMethodBodyFn<ConnectionRedirectBody>));
    insert(std::make_pair(createMapKey(10, 20, 0, 9), &createMethodBodyFn<ConnectionSecureBody>));
    insert(std::make_pair(createMapKey(10, 21, 0, 9), &createMethodBodyFn<ConnectionSecureOkBody>));
    insert(std::make_pair(createMapKey(10, 10, 0, 9), &createMethodBodyFn<ConnectionStartBody>));
    insert(std::make_pair(createMapKey(10, 11, 0, 9), &createMethodBodyFn<ConnectionStartOkBody>));
    insert(std::make_pair(createMapKey(10, 30, 0, 9), &createMethodBodyFn<ConnectionTuneBody>));
    insert(std::make_pair(createMapKey(10, 31, 0, 9), &createMethodBodyFn<ConnectionTuneOkBody>));
    insert(std::make_pair(createMapKey(100, 10, 0, 9), &createMethodBodyFn<DtxSelectBody>));
    insert(std::make_pair(createMapKey(100, 11, 0, 9), &createMethodBodyFn<DtxSelectOkBody>));
    insert(std::make_pair(createMapKey(100, 20, 0, 9), &createMethodBodyFn<DtxStartBody>));
    insert(std::make_pair(createMapKey(100, 21, 0, 9), &createMethodBodyFn<DtxStartOkBody>));
    insert(std::make_pair(createMapKey(40, 10, 0, 9), &createMethodBodyFn<ExchangeDeclareBody>));
    insert(std::make_pair(createMapKey(40, 11, 0, 9), &createMethodBodyFn<ExchangeDeclareOkBody>));
    insert(std::make_pair(createMapKey(40, 20, 0, 9), &createMethodBodyFn<ExchangeDeleteBody>));
    insert(std::make_pair(createMapKey(40, 21, 0, 9), &createMethodBodyFn<ExchangeDeleteOkBody>));
    insert(std::make_pair(createMapKey(70, 90, 0, 9), &createMethodBodyFn<FileAckBody>));
    insert(std::make_pair(createMapKey(70, 30, 0, 9), &createMethodBodyFn<FileCancelBody>));
    insert(std::make_pair(createMapKey(70, 31, 0, 9), &createMethodBodyFn<FileCancelOkBody>));
    insert(std::make_pair(createMapKey(70, 20, 0, 9), &createMethodBodyFn<FileConsumeBody>));
    insert(std::make_pair(createMapKey(70, 21, 0, 9), &createMethodBodyFn<FileConsumeOkBody>));
    insert(std::make_pair(createMapKey(70, 80, 0, 9), &createMethodBodyFn<FileDeliverBody>));
    insert(std::make_pair(createMapKey(70, 40, 0, 9), &createMethodBodyFn<FileOpenBody>));
    insert(std::make_pair(createMapKey(70, 41, 0, 9), &createMethodBodyFn<FileOpenOkBody>));
    insert(std::make_pair(createMapKey(70, 60, 0, 9), &createMethodBodyFn<FilePublishBody>));
    insert(std::make_pair(createMapKey(70, 10, 0, 9), &createMethodBodyFn<FileQosBody>));
    insert(std::make_pair(createMapKey(70, 11, 0, 9), &createMethodBodyFn<FileQosOkBody>));
    insert(std::make_pair(createMapKey(70, 100, 0, 9), &createMethodBodyFn<FileRejectBody>));
    insert(std::make_pair(createMapKey(70, 70, 0, 9), &createMethodBodyFn<FileReturnBody>));
    insert(std::make_pair(createMapKey(70, 50, 0, 9), &createMethodBodyFn<FileStageBody>));
    insert(std::make_pair(createMapKey(120, 80, 0, 9), &createMethodBodyFn<MessageAppendBody>));
    insert(std::make_pair(createMapKey(120, 30, 0, 9), &createMethodBodyFn<MessageCancelBody>));
    insert(std::make_pair(createMapKey(120, 90, 0, 9), &createMethodBodyFn<MessageCheckpointBody>));
    insert(std::make_pair(createMapKey(120, 70, 0, 9), &createMethodBodyFn<MessageCloseBody>));
    insert(std::make_pair(createMapKey(120, 20, 0, 9), &createMethodBodyFn<MessageConsumeBody>));
    insert(std::make_pair(createMapKey(120, 510, 0, 9), &createMethodBodyFn<MessageEmptyBody>));
    insert(std::make_pair(createMapKey(120, 40, 0, 9), &createMethodBodyFn<MessageGetBody>));
    insert(std::make_pair(createMapKey(120, 530, 0, 9), &createMethodBodyFn<MessageOffsetBody>));
    insert(std::make_pair(createMapKey(120, 500, 0, 9), &createMethodBodyFn<MessageOkBody>));
    insert(std::make_pair(createMapKey(120, 60, 0, 9), &createMethodBodyFn<MessageOpenBody>));
    insert(std::make_pair(createMapKey(120, 110, 0, 9), &createMethodBodyFn<MessageQosBody>));
    insert(std::make_pair(createMapKey(120, 50, 0, 9), &createMethodBodyFn<MessageRecoverBody>));
    insert(std::make_pair(createMapKey(120, 520, 0, 9), &createMethodBodyFn<MessageRejectBody>));
    insert(std::make_pair(createMapKey(120, 100, 0, 9), &createMethodBodyFn<MessageResumeBody>));
    insert(std::make_pair(createMapKey(120, 10, 0, 9), &createMethodBodyFn<MessageTransferBody>));
    insert(std::make_pair(createMapKey(50, 20, 0, 9), &createMethodBodyFn<QueueBindBody>));
    insert(std::make_pair(createMapKey(50, 21, 0, 9), &createMethodBodyFn<QueueBindOkBody>));
    insert(std::make_pair(createMapKey(50, 10, 0, 9), &createMethodBodyFn<QueueDeclareBody>));
    insert(std::make_pair(createMapKey(50, 11, 0, 9), &createMethodBodyFn<QueueDeclareOkBody>));
    insert(std::make_pair(createMapKey(50, 40, 0, 9), &createMethodBodyFn<QueueDeleteBody>));
    insert(std::make_pair(createMapKey(50, 41, 0, 9), &createMethodBodyFn<QueueDeleteOkBody>));
    insert(std::make_pair(createMapKey(50, 30, 0, 9), &createMethodBodyFn<QueuePurgeBody>));
    insert(std::make_pair(createMapKey(50, 31, 0, 9), &createMethodBodyFn<QueuePurgeOkBody>));
    insert(std::make_pair(createMapKey(50, 50, 0, 9), &createMethodBodyFn<QueueUnbindBody>));
    insert(std::make_pair(createMapKey(50, 51, 0, 9), &createMethodBodyFn<QueueUnbindOkBody>));
    insert(std::make_pair(createMapKey(80, 30, 0, 9), &createMethodBodyFn<StreamCancelBody>));
    insert(std::make_pair(createMapKey(80, 31, 0, 9), &createMethodBodyFn<StreamCancelOkBody>));
    insert(std::make_pair(createMapKey(80, 20, 0, 9), &createMethodBodyFn<StreamConsumeBody>));
    insert(std::make_pair(createMapKey(80, 21, 0, 9), &createMethodBodyFn<StreamConsumeOkBody>));
    insert(std::make_pair(createMapKey(80, 60, 0, 9), &createMethodBodyFn<StreamDeliverBody>));
    insert(std::make_pair(createMapKey(80, 40, 0, 9), &createMethodBodyFn<StreamPublishBody>));
    insert(std::make_pair(createMapKey(80, 10, 0, 9), &createMethodBodyFn<StreamQosBody>));
    insert(std::make_pair(createMapKey(80, 11, 0, 9), &createMethodBodyFn<StreamQosOkBody>));
    insert(std::make_pair(createMapKey(80, 50, 0, 9), &createMethodBodyFn<StreamReturnBody>));
    insert(std::make_pair(createMapKey(110, 10, 0, 9), &createMethodBodyFn<TunnelRequestBody>));
    insert(std::make_pair(createMapKey(90, 20, 0, 9), &createMethodBodyFn<TxCommitBody>));
    insert(std::make_pair(createMapKey(90, 21, 0, 9), &createMethodBodyFn<TxCommitOkBody>));
    insert(std::make_pair(createMapKey(90, 30, 0, 9), &createMethodBodyFn<TxRollbackBody>));
    insert(std::make_pair(createMapKey(90, 31, 0, 9), &createMethodBodyFn<TxRollbackOkBody>));
    insert(std::make_pair(createMapKey(90, 10, 0, 9), &createMethodBodyFn<TxSelectBody>));
    insert(std::make_pair(createMapKey(90, 11, 0, 9), &createMethodBodyFn<TxSelectOkBody>));
}
	
AMQMethodBody* AMQP_MethodVersionMap::createMethodBody(u_int16_t classId, u_int16_t methodId, u_int8_t major, u_int8_t minor)
{
	iterator itr = find(createMapKey(classId, methodId, major, minor));
	if (itr == end())
	{
		std::stringstream ss;
		ss << "Unable to find MethodBody class for classId = " << classId << ", methodId = " <<
		    methodId << ", AMQ protocol version = " << major << "-" << minor << ".";
   		throw ProtocolVersionException(ss.str());
   	}
   	return (itr->second)(major, minor);		
}

u_int64_t AMQP_MethodVersionMap::createMapKey(u_int16_t classId, u_int16_t methodId, u_int8_t major, u_int8_t minor)
{
	return ((u_int64_t)classId<<48) + ((u_int64_t)methodId<<32) + ((u_int64_t)major<<16) + minor;
}

} /* namespace framing */
} /* namespace qpid */
