/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_AMQP_MethodVersionMap__
#define qpid_framing_AMQP_MethodVersionMap__

#include <map>
#include "qpid/framing/AMQMethodBody.h"

#include "AccessRequestBody.h"
#include "AccessRequestOkBody.h"
#include "BasicAckBody.h"
#include "BasicCancelBody.h"
#include "BasicCancelOkBody.h"
#include "BasicConsumeBody.h"
#include "BasicConsumeOkBody.h"
#include "BasicDeliverBody.h"
#include "BasicGetBody.h"
#include "BasicGetEmptyBody.h"
#include "BasicGetOkBody.h"
#include "BasicPublishBody.h"
#include "BasicQosBody.h"
#include "BasicQosOkBody.h"
#include "BasicRecoverBody.h"
#include "BasicRejectBody.h"
#include "BasicReturnBody.h"
#include "ChannelCloseBody.h"
#include "ChannelCloseOkBody.h"
#include "ChannelFlowBody.h"
#include "ChannelFlowOkBody.h"
#include "ChannelOkBody.h"
#include "ChannelOpenBody.h"
#include "ChannelOpenOkBody.h"
#include "ChannelPingBody.h"
#include "ChannelPongBody.h"
#include "ChannelResumeBody.h"
#include "ConnectionCloseBody.h"
#include "ConnectionCloseOkBody.h"
#include "ConnectionOpenBody.h"
#include "ConnectionOpenOkBody.h"
#include "ConnectionRedirectBody.h"
#include "ConnectionSecureBody.h"
#include "ConnectionSecureOkBody.h"
#include "ConnectionStartBody.h"
#include "ConnectionStartOkBody.h"
#include "ConnectionTuneBody.h"
#include "ConnectionTuneOkBody.h"
#include "DtxSelectBody.h"
#include "DtxSelectOkBody.h"
#include "DtxStartBody.h"
#include "DtxStartOkBody.h"
#include "ExchangeDeclareBody.h"
#include "ExchangeDeclareOkBody.h"
#include "ExchangeDeleteBody.h"
#include "ExchangeDeleteOkBody.h"
#include "FileAckBody.h"
#include "FileCancelBody.h"
#include "FileCancelOkBody.h"
#include "FileConsumeBody.h"
#include "FileConsumeOkBody.h"
#include "FileDeliverBody.h"
#include "FileOpenBody.h"
#include "FileOpenOkBody.h"
#include "FilePublishBody.h"
#include "FileQosBody.h"
#include "FileQosOkBody.h"
#include "FileRejectBody.h"
#include "FileReturnBody.h"
#include "FileStageBody.h"
#include "MessageAppendBody.h"
#include "MessageCancelBody.h"
#include "MessageCheckpointBody.h"
#include "MessageCloseBody.h"
#include "MessageConsumeBody.h"
#include "MessageEmptyBody.h"
#include "MessageGetBody.h"
#include "MessageOffsetBody.h"
#include "MessageOkBody.h"
#include "MessageOpenBody.h"
#include "MessageQosBody.h"
#include "MessageRecoverBody.h"
#include "MessageRejectBody.h"
#include "MessageResumeBody.h"
#include "MessageTransferBody.h"
#include "QueueBindBody.h"
#include "QueueBindOkBody.h"
#include "QueueDeclareBody.h"
#include "QueueDeclareOkBody.h"
#include "QueueDeleteBody.h"
#include "QueueDeleteOkBody.h"
#include "QueuePurgeBody.h"
#include "QueuePurgeOkBody.h"
#include "QueueUnbindBody.h"
#include "QueueUnbindOkBody.h"
#include "StreamCancelBody.h"
#include "StreamCancelOkBody.h"
#include "StreamConsumeBody.h"
#include "StreamConsumeOkBody.h"
#include "StreamDeliverBody.h"
#include "StreamPublishBody.h"
#include "StreamQosBody.h"
#include "StreamQosOkBody.h"
#include "StreamReturnBody.h"
#include "TunnelRequestBody.h"
#include "TxCommitBody.h"
#include "TxCommitOkBody.h"
#include "TxRollbackBody.h"
#include "TxRollbackOkBody.h"
#include "TxSelectBody.h"
#include "TxSelectOkBody.h"

namespace qpid
{
namespace framing
{

template <class T> AMQMethodBody* createMethodBodyFn(u_int8_t major, u_int8_t minor) { return new T(ProtocolVersion(major, minor)); }
typedef AMQMethodBody* (*fnPtr)(u_int8_t, u_int8_t);

class AMQP_MethodVersionMap: public std::map<u_int64_t, fnPtr>
{
protected:
	u_int64_t createMapKey(u_int16_t classId, u_int16_t methodId, u_int8_t major, u_int8_t minor);
public:
	AMQP_MethodVersionMap();
	AMQMethodBody* createMethodBody(u_int16_t classId, u_int16_t methodId, u_int8_t major, u_int8_t minor);
};

} /* namespace framing */
} /* namespace qpid */

#endif
