/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#include <sstream>
#include "AMQP_ServerProxy.h"
#include "qpid/framing/ChannelAdapter.h"
#include "qpid/framing/amqp_types_full.h"

#include "AccessRequestBody.h"
#include "AccessRequestOkBody.h"
#include "BasicAckBody.h"
#include "BasicCancelBody.h"
#include "BasicCancelOkBody.h"
#include "BasicConsumeBody.h"
#include "BasicConsumeOkBody.h"
#include "BasicDeliverBody.h"
#include "BasicGetBody.h"
#include "BasicGetEmptyBody.h"
#include "BasicGetOkBody.h"
#include "BasicPublishBody.h"
#include "BasicQosBody.h"
#include "BasicQosOkBody.h"
#include "BasicRecoverBody.h"
#include "BasicRejectBody.h"
#include "BasicReturnBody.h"
#include "ChannelCloseBody.h"
#include "ChannelCloseOkBody.h"
#include "ChannelFlowBody.h"
#include "ChannelFlowOkBody.h"
#include "ChannelOkBody.h"
#include "ChannelOpenBody.h"
#include "ChannelOpenOkBody.h"
#include "ChannelPingBody.h"
#include "ChannelPongBody.h"
#include "ChannelResumeBody.h"
#include "ConnectionCloseBody.h"
#include "ConnectionCloseOkBody.h"
#include "ConnectionOpenBody.h"
#include "ConnectionOpenOkBody.h"
#include "ConnectionRedirectBody.h"
#include "ConnectionSecureBody.h"
#include "ConnectionSecureOkBody.h"
#include "ConnectionStartBody.h"
#include "ConnectionStartOkBody.h"
#include "ConnectionTuneBody.h"
#include "ConnectionTuneOkBody.h"
#include "DtxSelectBody.h"
#include "DtxSelectOkBody.h"
#include "DtxStartBody.h"
#include "DtxStartOkBody.h"
#include "ExchangeDeclareBody.h"
#include "ExchangeDeclareOkBody.h"
#include "ExchangeDeleteBody.h"
#include "ExchangeDeleteOkBody.h"
#include "FileAckBody.h"
#include "FileCancelBody.h"
#include "FileCancelOkBody.h"
#include "FileConsumeBody.h"
#include "FileConsumeOkBody.h"
#include "FileDeliverBody.h"
#include "FileOpenBody.h"
#include "FileOpenOkBody.h"
#include "FilePublishBody.h"
#include "FileQosBody.h"
#include "FileQosOkBody.h"
#include "FileRejectBody.h"
#include "FileReturnBody.h"
#include "FileStageBody.h"
#include "MessageAppendBody.h"
#include "MessageCancelBody.h"
#include "MessageCheckpointBody.h"
#include "MessageCloseBody.h"
#include "MessageConsumeBody.h"
#include "MessageEmptyBody.h"
#include "MessageGetBody.h"
#include "MessageOffsetBody.h"
#include "MessageOkBody.h"
#include "MessageOpenBody.h"
#include "MessageQosBody.h"
#include "MessageRecoverBody.h"
#include "MessageRejectBody.h"
#include "MessageResumeBody.h"
#include "MessageTransferBody.h"
#include "QueueBindBody.h"
#include "QueueBindOkBody.h"
#include "QueueDeclareBody.h"
#include "QueueDeclareOkBody.h"
#include "QueueDeleteBody.h"
#include "QueueDeleteOkBody.h"
#include "QueuePurgeBody.h"
#include "QueuePurgeOkBody.h"
#include "QueueUnbindBody.h"
#include "QueueUnbindOkBody.h"
#include "StreamCancelBody.h"
#include "StreamCancelOkBody.h"
#include "StreamConsumeBody.h"
#include "StreamConsumeOkBody.h"
#include "StreamDeliverBody.h"
#include "StreamPublishBody.h"
#include "StreamQosBody.h"
#include "StreamQosOkBody.h"
#include "StreamReturnBody.h"
#include "TunnelRequestBody.h"
#include "TxCommitBody.h"
#include "TxCommitOkBody.h"
#include "TxRollbackBody.h"
#include "TxRollbackOkBody.h"
#include "TxSelectBody.h"
#include "TxSelectOkBody.h"

namespace qpid {
namespace framing {

AMQP_ServerProxy::AMQP_ServerProxy(ChannelAdapter& ch) :
    Proxy(ch),
    accessProxy(channel),
    basicProxy(channel),
    channelProxy(channel),
    connectionProxy(channel),
    dtxProxy(channel),
    exchangeProxy(channel),
    fileProxy(channel),
    messageProxy(channel),
    queueProxy(channel),
    streamProxy(channel),
    tunnelProxy(channel),
    txProxy(channel)
    {}

    // Inner class instance get methods
	
AMQP_ServerProxy::Access& AMQP_ServerProxy::getAccess()
{
    return accessProxy;
}

AMQP_ServerProxy::Basic& AMQP_ServerProxy::getBasic()
{
    return basicProxy;
}

AMQP_ServerProxy::Channel& AMQP_ServerProxy::getChannel()
{
    return channelProxy;
}

AMQP_ServerProxy::Connection& AMQP_ServerProxy::getConnection()
{
    return connectionProxy;
}

AMQP_ServerProxy::Dtx& AMQP_ServerProxy::getDtx()
{
    return dtxProxy;
}

AMQP_ServerProxy::Exchange& AMQP_ServerProxy::getExchange()
{
    return exchangeProxy;
}

AMQP_ServerProxy::File& AMQP_ServerProxy::getFile()
{
    return fileProxy;
}

AMQP_ServerProxy::Message& AMQP_ServerProxy::getMessage()
{
    return messageProxy;
}

AMQP_ServerProxy::Queue& AMQP_ServerProxy::getQueue()
{
    return queueProxy;
}

AMQP_ServerProxy::Stream& AMQP_ServerProxy::getStream()
{
    return streamProxy;
}

AMQP_ServerProxy::Tunnel& AMQP_ServerProxy::getTunnel()
{
    return tunnelProxy;
}

AMQP_ServerProxy::Tx& AMQP_ServerProxy::getTx()
{
    return txProxy;
}

    // Inner class implementation

// ==================== class Access ====================
RequestId AMQP_ServerProxy::Access::request(const string& realm,
                    bool exclusive,
                    bool passive,
                    bool active,
                    bool write,
                    bool read)
{
        return channel.send(new AccessRequestBody( channel.getVersion(),
                         realm,
                         exclusive,
                         passive,
                         active,
                         write,
                         read));
}


// ==================== class Basic ====================
RequestId AMQP_ServerProxy::Basic::ack(u_int64_t deliveryTag,
                    bool multiple)
{
        return channel.send(new BasicAckBody( channel.getVersion(),
                         deliveryTag,
                         multiple));
}


RequestId AMQP_ServerProxy::Basic::cancel(const string& consumerTag,
                    bool nowait)
{
        return channel.send(new BasicCancelBody( channel.getVersion(),
                         consumerTag,
                         nowait));
}


RequestId AMQP_ServerProxy::Basic::consume(u_int16_t ticket,
                    const string& queue,
                    const string& consumerTag,
                    bool noLocal,
                    bool noAck,
                    bool exclusive,
                    bool nowait,
                    const FieldTable& filter)
{
        return channel.send(new BasicConsumeBody( channel.getVersion(),
                         ticket,
                         queue,
                         consumerTag,
                         noLocal,
                         noAck,
                         exclusive,
                         nowait,
                         filter));
}


RequestId AMQP_ServerProxy::Basic::get(u_int16_t ticket,
                    const string& queue,
                    bool noAck)
{
        return channel.send(new BasicGetBody( channel.getVersion(),
                         ticket,
                         queue,
                         noAck));
}


RequestId AMQP_ServerProxy::Basic::publish(u_int16_t ticket,
                    const string& exchange,
                    const string& routingKey,
                    bool mandatory,
                    bool immediate)
{
        return channel.send(new BasicPublishBody( channel.getVersion(),
                         ticket,
                         exchange,
                         routingKey,
                         mandatory,
                         immediate));
}


RequestId AMQP_ServerProxy::Basic::qos(u_int32_t prefetchSize,
                    u_int16_t prefetchCount,
                    bool global)
{
        return channel.send(new BasicQosBody( channel.getVersion(),
                         prefetchSize,
                         prefetchCount,
                         global));
}


RequestId AMQP_ServerProxy::Basic::recover(bool requeue)
{
        return channel.send(new BasicRecoverBody( channel.getVersion(),
                         requeue));
}


RequestId AMQP_ServerProxy::Basic::reject(u_int64_t deliveryTag,
                    bool requeue)
{
        return channel.send(new BasicRejectBody( channel.getVersion(),
                         deliveryTag,
                         requeue));
}


// ==================== class Channel ====================
RequestId AMQP_ServerProxy::Channel::close(u_int16_t replyCode,
                    const string& replyText,
                    u_int16_t classId,
                    u_int16_t methodId)
{
        return channel.send(new ChannelCloseBody( channel.getVersion(),
                         replyCode,
                         replyText,
                         classId,
                         methodId));
}


void AMQP_ServerProxy::Channel::closeOk(RequestId responseTo)
{
        channel.send(new ChannelCloseOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ServerProxy::Channel::flow(bool active)
{
        return channel.send(new ChannelFlowBody( channel.getVersion(),
                         active));
}


void AMQP_ServerProxy::Channel::flowOk(bool active, RequestId responseTo)
{
        channel.send(new ChannelFlowOkBody( channel.getVersion(), responseTo,
                         active));
}


void AMQP_ServerProxy::Channel::ok(RequestId responseTo)
{
        channel.send(new ChannelOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ServerProxy::Channel::open(const string& outOfBand)
{
        return channel.send(new ChannelOpenBody( channel.getVersion(),
                         outOfBand));
}


RequestId AMQP_ServerProxy::Channel::ping()
{
        return channel.send(new ChannelPingBody( channel.getVersion()));
}


RequestId AMQP_ServerProxy::Channel::pong()
{
        return channel.send(new ChannelPongBody( channel.getVersion()));
}


RequestId AMQP_ServerProxy::Channel::resume(const string& channelId)
{
        return channel.send(new ChannelResumeBody( channel.getVersion(),
                         channelId));
}


// ==================== class Connection ====================
RequestId AMQP_ServerProxy::Connection::close(u_int16_t replyCode,
                    const string& replyText,
                    u_int16_t classId,
                    u_int16_t methodId)
{
        return channel.send(new ConnectionCloseBody( channel.getVersion(),
                         replyCode,
                         replyText,
                         classId,
                         methodId));
}


void AMQP_ServerProxy::Connection::closeOk(RequestId responseTo)
{
        channel.send(new ConnectionCloseOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ServerProxy::Connection::open(const string& virtualHost,
                    const string& capabilities,
                    bool insist)
{
        return channel.send(new ConnectionOpenBody( channel.getVersion(),
                         virtualHost,
                         capabilities,
                         insist));
}


void AMQP_ServerProxy::Connection::secureOk(const string& response, RequestId responseTo)
{
        channel.send(new ConnectionSecureOkBody( channel.getVersion(), responseTo,
                         response));
}


void AMQP_ServerProxy::Connection::startOk(const FieldTable& clientProperties,
                    const string& mechanism,
                    const string& response,
                    const string& locale, RequestId responseTo)
{
        channel.send(new ConnectionStartOkBody( channel.getVersion(), responseTo,
                         clientProperties,
                         mechanism,
                         response,
                         locale));
}


void AMQP_ServerProxy::Connection::tuneOk(u_int16_t channelMax,
                    u_int32_t frameMax,
                    u_int16_t heartbeat, RequestId responseTo)
{
        channel.send(new ConnectionTuneOkBody( channel.getVersion(), responseTo,
                         channelMax,
                         frameMax,
                         heartbeat));
}


// ==================== class Dtx ====================
RequestId AMQP_ServerProxy::Dtx::select()
{
        return channel.send(new DtxSelectBody( channel.getVersion()));
}


RequestId AMQP_ServerProxy::Dtx::start(const string& dtxIdentifier)
{
        return channel.send(new DtxStartBody( channel.getVersion(),
                         dtxIdentifier));
}


// ==================== class Exchange ====================
RequestId AMQP_ServerProxy::Exchange::declare(u_int16_t ticket,
                    const string& exchange,
                    const string& type,
                    bool passive,
                    bool durable,
                    bool autoDelete,
                    bool internal,
                    bool nowait,
                    const FieldTable& arguments)
{
        return channel.send(new ExchangeDeclareBody( channel.getVersion(),
                         ticket,
                         exchange,
                         type,
                         passive,
                         durable,
                         autoDelete,
                         internal,
                         nowait,
                         arguments));
}


RequestId AMQP_ServerProxy::Exchange::delete_(u_int16_t ticket,
                    const string& exchange,
                    bool ifUnused,
                    bool nowait)
{
        return channel.send(new ExchangeDeleteBody( channel.getVersion(),
                         ticket,
                         exchange,
                         ifUnused,
                         nowait));
}


// ==================== class File ====================
RequestId AMQP_ServerProxy::File::ack(u_int64_t deliveryTag,
                    bool multiple)
{
        return channel.send(new FileAckBody( channel.getVersion(),
                         deliveryTag,
                         multiple));
}


RequestId AMQP_ServerProxy::File::cancel(const string& consumerTag,
                    bool nowait)
{
        return channel.send(new FileCancelBody( channel.getVersion(),
                         consumerTag,
                         nowait));
}


RequestId AMQP_ServerProxy::File::consume(u_int16_t ticket,
                    const string& queue,
                    const string& consumerTag,
                    bool noLocal,
                    bool noAck,
                    bool exclusive,
                    bool nowait,
                    const FieldTable& filter)
{
        return channel.send(new FileConsumeBody( channel.getVersion(),
                         ticket,
                         queue,
                         consumerTag,
                         noLocal,
                         noAck,
                         exclusive,
                         nowait,
                         filter));
}


RequestId AMQP_ServerProxy::File::open(const string& identifier,
                    u_int64_t contentSize)
{
        return channel.send(new FileOpenBody( channel.getVersion(),
                         identifier,
                         contentSize));
}


void AMQP_ServerProxy::File::openOk(u_int64_t stagedSize, RequestId responseTo)
{
        channel.send(new FileOpenOkBody( channel.getVersion(), responseTo,
                         stagedSize));
}


RequestId AMQP_ServerProxy::File::publish(u_int16_t ticket,
                    const string& exchange,
                    const string& routingKey,
                    bool mandatory,
                    bool immediate,
                    const string& identifier)
{
        return channel.send(new FilePublishBody( channel.getVersion(),
                         ticket,
                         exchange,
                         routingKey,
                         mandatory,
                         immediate,
                         identifier));
}


RequestId AMQP_ServerProxy::File::qos(u_int32_t prefetchSize,
                    u_int16_t prefetchCount,
                    bool global)
{
        return channel.send(new FileQosBody( channel.getVersion(),
                         prefetchSize,
                         prefetchCount,
                         global));
}


RequestId AMQP_ServerProxy::File::reject(u_int64_t deliveryTag,
                    bool requeue)
{
        return channel.send(new FileRejectBody( channel.getVersion(),
                         deliveryTag,
                         requeue));
}


void AMQP_ServerProxy::File::stage(RequestId responseTo)
{
        channel.send(new FileStageBody( channel.getVersion(), responseTo));
}


// ==================== class Message ====================
RequestId AMQP_ServerProxy::Message::append(const string& reference,
                    const string& bytes)
{
        return channel.send(new MessageAppendBody( channel.getVersion(),
                         reference,
                         bytes));
}


RequestId AMQP_ServerProxy::Message::cancel(const string& destination)
{
        return channel.send(new MessageCancelBody( channel.getVersion(),
                         destination));
}


RequestId AMQP_ServerProxy::Message::checkpoint(const string& reference,
                    const string& identifier)
{
        return channel.send(new MessageCheckpointBody( channel.getVersion(),
                         reference,
                         identifier));
}


RequestId AMQP_ServerProxy::Message::close(const string& reference)
{
        return channel.send(new MessageCloseBody( channel.getVersion(),
                         reference));
}


RequestId AMQP_ServerProxy::Message::consume(u_int16_t ticket,
                    const string& queue,
                    const string& destination,
                    bool noLocal,
                    bool noAck,
                    bool exclusive,
                    const FieldTable& filter)
{
        return channel.send(new MessageConsumeBody( channel.getVersion(),
                         ticket,
                         queue,
                         destination,
                         noLocal,
                         noAck,
                         exclusive,
                         filter));
}


void AMQP_ServerProxy::Message::empty(RequestId responseTo)
{
        channel.send(new MessageEmptyBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ServerProxy::Message::get(u_int16_t ticket,
                    const string& queue,
                    const string& destination,
                    bool noAck)
{
        return channel.send(new MessageGetBody( channel.getVersion(),
                         ticket,
                         queue,
                         destination,
                         noAck));
}


void AMQP_ServerProxy::Message::offset(u_int64_t value, RequestId responseTo)
{
        channel.send(new MessageOffsetBody( channel.getVersion(), responseTo,
                         value));
}


void AMQP_ServerProxy::Message::ok(RequestId responseTo)
{
        channel.send(new MessageOkBody( channel.getVersion(), responseTo));
}


RequestId AMQP_ServerProxy::Message::open(const string& reference)
{
        return channel.send(new MessageOpenBody( channel.getVersion(),
                         reference));
}


RequestId AMQP_ServerProxy::Message::qos(u_int32_t prefetchSize,
                    u_int16_t prefetchCount,
                    bool global)
{
        return channel.send(new MessageQosBody( channel.getVersion(),
                         prefetchSize,
                         prefetchCount,
                         global));
}


RequestId AMQP_ServerProxy::Message::recover(bool requeue)
{
        return channel.send(new MessageRecoverBody( channel.getVersion(),
                         requeue));
}


void AMQP_ServerProxy::Message::reject(u_int16_t code,
                    const string& text, RequestId responseTo)
{
        channel.send(new MessageRejectBody( channel.getVersion(), responseTo,
                         code,
                         text));
}


RequestId AMQP_ServerProxy::Message::resume(const string& reference,
                    const string& identifier)
{
        return channel.send(new MessageResumeBody( channel.getVersion(),
                         reference,
                         identifier));
}


RequestId AMQP_ServerProxy::Message::transfer(u_int16_t ticket,
                    const string& destination,
                    bool redelivered,
                    bool immediate,
                    u_int64_t ttl,
                    u_int8_t priority,
                    u_int64_t timestamp,
                    u_int8_t deliveryMode,
                    u_int64_t expiration,
                    const string& exchange,
                    const string& routingKey,
                    const string& messageId,
                    const string& correlationId,
                    const string& replyTo,
                    const string& contentType,
                    const string& contentEncoding,
                    const string& userId,
                    const string& appId,
                    const string& transactionId,
                    const string& securityToken,
                    const FieldTable& applicationHeaders,
                    const Content& body,
                    bool mandatory)
{
        return channel.send(new MessageTransferBody( channel.getVersion(),
                         ticket,
                         destination,
                         redelivered,
                         immediate,
                         ttl,
                         priority,
                         timestamp,
                         deliveryMode,
                         expiration,
                         exchange,
                         routingKey,
                         messageId,
                         correlationId,
                         replyTo,
                         contentType,
                         contentEncoding,
                         userId,
                         appId,
                         transactionId,
                         securityToken,
                         applicationHeaders,
                         body,
                         mandatory));
}


// ==================== class Queue ====================
RequestId AMQP_ServerProxy::Queue::bind(u_int16_t ticket,
                    const string& queue,
                    const string& exchange,
                    const string& routingKey,
                    bool nowait,
                    const FieldTable& arguments)
{
        return channel.send(new QueueBindBody( channel.getVersion(),
                         ticket,
                         queue,
                         exchange,
                         routingKey,
                         nowait,
                         arguments));
}


RequestId AMQP_ServerProxy::Queue::declare(u_int16_t ticket,
                    const string& queue,
                    bool passive,
                    bool durable,
                    bool exclusive,
                    bool autoDelete,
                    bool nowait,
                    const FieldTable& arguments)
{
        return channel.send(new QueueDeclareBody( channel.getVersion(),
                         ticket,
                         queue,
                         passive,
                         durable,
                         exclusive,
                         autoDelete,
                         nowait,
                         arguments));
}


RequestId AMQP_ServerProxy::Queue::delete_(u_int16_t ticket,
                    const string& queue,
                    bool ifUnused,
                    bool ifEmpty,
                    bool nowait)
{
        return channel.send(new QueueDeleteBody( channel.getVersion(),
                         ticket,
                         queue,
                         ifUnused,
                         ifEmpty,
                         nowait));
}


RequestId AMQP_ServerProxy::Queue::purge(u_int16_t ticket,
                    const string& queue,
                    bool nowait)
{
        return channel.send(new QueuePurgeBody( channel.getVersion(),
                         ticket,
                         queue,
                         nowait));
}


RequestId AMQP_ServerProxy::Queue::unbind(u_int16_t ticket,
                    const string& queue,
                    const string& exchange,
                    const string& routingKey,
                    const FieldTable& arguments)
{
        return channel.send(new QueueUnbindBody( channel.getVersion(),
                         ticket,
                         queue,
                         exchange,
                         routingKey,
                         arguments));
}


// ==================== class Stream ====================
RequestId AMQP_ServerProxy::Stream::cancel(const string& consumerTag,
                    bool nowait)
{
        return channel.send(new StreamCancelBody( channel.getVersion(),
                         consumerTag,
                         nowait));
}


RequestId AMQP_ServerProxy::Stream::consume(u_int16_t ticket,
                    const string& queue,
                    const string& consumerTag,
                    bool noLocal,
                    bool exclusive,
                    bool nowait,
                    const FieldTable& filter)
{
        return channel.send(new StreamConsumeBody( channel.getVersion(),
                         ticket,
                         queue,
                         consumerTag,
                         noLocal,
                         exclusive,
                         nowait,
                         filter));
}


RequestId AMQP_ServerProxy::Stream::publish(u_int16_t ticket,
                    const string& exchange,
                    const string& routingKey,
                    bool mandatory,
                    bool immediate)
{
        return channel.send(new StreamPublishBody( channel.getVersion(),
                         ticket,
                         exchange,
                         routingKey,
                         mandatory,
                         immediate));
}


RequestId AMQP_ServerProxy::Stream::qos(u_int32_t prefetchSize,
                    u_int16_t prefetchCount,
                    u_int32_t consumeRate,
                    bool global)
{
        return channel.send(new StreamQosBody( channel.getVersion(),
                         prefetchSize,
                         prefetchCount,
                         consumeRate,
                         global));
}


// ==================== class Tunnel ====================
RequestId AMQP_ServerProxy::Tunnel::request(const FieldTable& metaData)
{
        return channel.send(new TunnelRequestBody( channel.getVersion(),
                         metaData));
}


// ==================== class Tx ====================
RequestId AMQP_ServerProxy::Tx::commit()
{
        return channel.send(new TxCommitBody( channel.getVersion()));
}


RequestId AMQP_ServerProxy::Tx::rollback()
{
        return channel.send(new TxRollbackBody( channel.getVersion()));
}


RequestId AMQP_ServerProxy::Tx::select()
{
        return channel.send(new TxSelectBody( channel.getVersion()));
}


}} // namespae qpid::framing 
