/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_AMQP_ServerProxy__
#define qpid_framing_AMQP_ServerProxy__

#include "qpid/framing/Proxy.h"

namespace qpid {
namespace framing {

class AMQP_ServerProxy : public Proxy
{
public:
    AMQP_ServerProxy(ChannelAdapter& ch);

    // Inner class definitions

    // ==================== class Access ====================
    class Access
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Access(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Access() {}

        static Access& get(AMQP_ServerProxy& proxy) { return proxy.getAccess();}

        // Protocol methods

        virtual RequestId request(const string& realm,
                            bool exclusive,
                            bool passive,
                            bool active,
                            bool write,
                            bool read );
    }; // class Access

    // ==================== class Basic ====================
    class Basic
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Basic(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Basic() {}

        static Basic& get(AMQP_ServerProxy& proxy) { return proxy.getBasic();}

        // Protocol methods

        virtual RequestId ack(u_int64_t deliveryTag,
                            bool multiple );

        virtual RequestId cancel(const string& consumerTag,
                            bool nowait );

        virtual RequestId consume(u_int16_t ticket,
                            const string& queue,
                            const string& consumerTag,
                            bool noLocal,
                            bool noAck,
                            bool exclusive,
                            bool nowait,
                            const FieldTable& filter );

        virtual RequestId get(u_int16_t ticket,
                            const string& queue,
                            bool noAck );

        virtual RequestId publish(u_int16_t ticket,
                            const string& exchange,
                            const string& routingKey,
                            bool mandatory,
                            bool immediate );

        virtual RequestId qos(u_int32_t prefetchSize,
                            u_int16_t prefetchCount,
                            bool global );

        virtual RequestId recover(bool requeue );

        virtual RequestId reject(u_int64_t deliveryTag,
                            bool requeue );
    }; // class Basic

    // ==================== class Channel ====================
    class Channel
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Channel(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Channel() {}

        static Channel& get(AMQP_ServerProxy& proxy) { return proxy.getChannel();}

        // Protocol methods

        virtual RequestId close(u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId );

        virtual void closeOk(	RequestId responseTo );

        virtual RequestId flow(bool active );

        virtual void flowOk(bool active, 
                            	RequestId responseTo );

        virtual void ok(	RequestId responseTo );

        virtual RequestId open(const string& outOfBand );

        virtual RequestId ping( );

        virtual RequestId pong( );

        virtual RequestId resume(const string& channelId );
    }; // class Channel

    // ==================== class Connection ====================
    class Connection
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Connection(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Connection() {}

        static Connection& get(AMQP_ServerProxy& proxy) { return proxy.getConnection();}

        // Protocol methods

        virtual RequestId close(u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId );

        virtual void closeOk(	RequestId responseTo );

        virtual RequestId open(const string& virtualHost,
                            const string& capabilities,
                            bool insist );

        virtual void secureOk(const string& response, 
                            	RequestId responseTo );

        virtual void startOk(const FieldTable& clientProperties,
                            const string& mechanism,
                            const string& response,
                            const string& locale, 
                            	RequestId responseTo );

        virtual void tuneOk(u_int16_t channelMax,
                            u_int32_t frameMax,
                            u_int16_t heartbeat, 
                            	RequestId responseTo );
    }; // class Connection

    // ==================== class Dtx ====================
    class Dtx
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Dtx(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Dtx() {}

        static Dtx& get(AMQP_ServerProxy& proxy) { return proxy.getDtx();}

        // Protocol methods

        virtual RequestId select( );

        virtual RequestId start(const string& dtxIdentifier );
    }; // class Dtx

    // ==================== class Exchange ====================
    class Exchange
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Exchange(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Exchange() {}

        static Exchange& get(AMQP_ServerProxy& proxy) { return proxy.getExchange();}

        // Protocol methods

        virtual RequestId declare(u_int16_t ticket,
                            const string& exchange,
                            const string& type,
                            bool passive,
                            bool durable,
                            bool autoDelete,
                            bool internal,
                            bool nowait,
                            const FieldTable& arguments );

        virtual RequestId delete_(u_int16_t ticket,
                            const string& exchange,
                            bool ifUnused,
                            bool nowait );
    }; // class Exchange

    // ==================== class File ====================
    class File
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        File(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~File() {}

        static File& get(AMQP_ServerProxy& proxy) { return proxy.getFile();}

        // Protocol methods

        virtual RequestId ack(u_int64_t deliveryTag,
                            bool multiple );

        virtual RequestId cancel(const string& consumerTag,
                            bool nowait );

        virtual RequestId consume(u_int16_t ticket,
                            const string& queue,
                            const string& consumerTag,
                            bool noLocal,
                            bool noAck,
                            bool exclusive,
                            bool nowait,
                            const FieldTable& filter );

        virtual RequestId open(const string& identifier,
                            u_int64_t contentSize );

        virtual void openOk(u_int64_t stagedSize, 
                            	RequestId responseTo );

        virtual RequestId publish(u_int16_t ticket,
                            const string& exchange,
                            const string& routingKey,
                            bool mandatory,
                            bool immediate,
                            const string& identifier );

        virtual RequestId qos(u_int32_t prefetchSize,
                            u_int16_t prefetchCount,
                            bool global );

        virtual RequestId reject(u_int64_t deliveryTag,
                            bool requeue );

        virtual void stage(	RequestId responseTo );
    }; // class File

    // ==================== class Message ====================
    class Message
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Message(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Message() {}

        static Message& get(AMQP_ServerProxy& proxy) { return proxy.getMessage();}

        // Protocol methods

        virtual RequestId append(const string& reference,
                            const string& bytes );

        virtual RequestId cancel(const string& destination );

        virtual RequestId checkpoint(const string& reference,
                            const string& identifier );

        virtual RequestId close(const string& reference );

        virtual RequestId consume(u_int16_t ticket,
                            const string& queue,
                            const string& destination,
                            bool noLocal,
                            bool noAck,
                            bool exclusive,
                            const FieldTable& filter );

        virtual void empty(	RequestId responseTo );

        virtual RequestId get(u_int16_t ticket,
                            const string& queue,
                            const string& destination,
                            bool noAck );

        virtual void offset(u_int64_t value, 
                            	RequestId responseTo );

        virtual void ok(	RequestId responseTo );

        virtual RequestId open(const string& reference );

        virtual RequestId qos(u_int32_t prefetchSize,
                            u_int16_t prefetchCount,
                            bool global );

        virtual RequestId recover(bool requeue );

        virtual void reject(u_int16_t code,
                            const string& text, 
                            	RequestId responseTo );

        virtual RequestId resume(const string& reference,
                            const string& identifier );

        virtual RequestId transfer(u_int16_t ticket,
                            const string& destination,
                            bool redelivered,
                            bool immediate,
                            u_int64_t ttl,
                            u_int8_t priority,
                            u_int64_t timestamp,
                            u_int8_t deliveryMode,
                            u_int64_t expiration,
                            const string& exchange,
                            const string& routingKey,
                            const string& messageId,
                            const string& correlationId,
                            const string& replyTo,
                            const string& contentType,
                            const string& contentEncoding,
                            const string& userId,
                            const string& appId,
                            const string& transactionId,
                            const string& securityToken,
                            const FieldTable& applicationHeaders,
                            const Content& body,
                            bool mandatory );
    }; // class Message

    // ==================== class Queue ====================
    class Queue
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Queue(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Queue() {}

        static Queue& get(AMQP_ServerProxy& proxy) { return proxy.getQueue();}

        // Protocol methods

        virtual RequestId bind(u_int16_t ticket,
                            const string& queue,
                            const string& exchange,
                            const string& routingKey,
                            bool nowait,
                            const FieldTable& arguments );

        virtual RequestId declare(u_int16_t ticket,
                            const string& queue,
                            bool passive,
                            bool durable,
                            bool exclusive,
                            bool autoDelete,
                            bool nowait,
                            const FieldTable& arguments );

        virtual RequestId delete_(u_int16_t ticket,
                            const string& queue,
                            bool ifUnused,
                            bool ifEmpty,
                            bool nowait );

        virtual RequestId purge(u_int16_t ticket,
                            const string& queue,
                            bool nowait );

        virtual RequestId unbind(u_int16_t ticket,
                            const string& queue,
                            const string& exchange,
                            const string& routingKey,
                            const FieldTable& arguments );
    }; // class Queue

    // ==================== class Stream ====================
    class Stream
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Stream(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Stream() {}

        static Stream& get(AMQP_ServerProxy& proxy) { return proxy.getStream();}

        // Protocol methods

        virtual RequestId cancel(const string& consumerTag,
                            bool nowait );

        virtual RequestId consume(u_int16_t ticket,
                            const string& queue,
                            const string& consumerTag,
                            bool noLocal,
                            bool exclusive,
                            bool nowait,
                            const FieldTable& filter );

        virtual RequestId publish(u_int16_t ticket,
                            const string& exchange,
                            const string& routingKey,
                            bool mandatory,
                            bool immediate );

        virtual RequestId qos(u_int32_t prefetchSize,
                            u_int16_t prefetchCount,
                            u_int32_t consumeRate,
                            bool global );
    }; // class Stream

    // ==================== class Tunnel ====================
    class Tunnel
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Tunnel(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Tunnel() {}

        static Tunnel& get(AMQP_ServerProxy& proxy) { return proxy.getTunnel();}

        // Protocol methods

        virtual RequestId request(const FieldTable& metaData );
    }; // class Tunnel

    // ==================== class Tx ====================
    class Tx
    {
    private:
        ChannelAdapter& channel;

    public:
        // Constructors and destructors

        Tx(ChannelAdapter& ch) : 
            channel(ch) {}
        virtual ~Tx() {}

        static Tx& get(AMQP_ServerProxy& proxy) { return proxy.getTx();}

        // Protocol methods

        virtual RequestId commit( );

        virtual RequestId rollback( );

        virtual RequestId select( );
    }; // class Tx

    // Inner class instance get methods
	
    Access& getAccess();
    Basic& getBasic();
    Channel& getChannel();
    Connection& getConnection();
    Dtx& getDtx();
    Exchange& getExchange();
    File& getFile();
    Message& getMessage();
    Queue& getQueue();
    Stream& getStream();
    Tunnel& getTunnel();
    Tx& getTx();
    
private:
    // Inner class instances
	
    Access accessProxy;
    Basic basicProxy;
    Channel channelProxy;
    Connection connectionProxy;
    Dtx dtxProxy;
    Exchange exchangeProxy;
    File fileProxy;
    Message messageProxy;
    Queue queueProxy;
    Stream streamProxy;
    Tunnel tunnelProxy;
    Tx txProxy;
}; /* class AMQP_ServerProxy */

} /* namespace framing */
} /* namespace qpid */

#endif
