/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_AccessRequestBody__
#define qpid_framing_AccessRequestBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class AccessRequestBody : public AMQRequestBody
{

        // Method field declarations

    string realm;
    bool exclusive;
    bool passive;
    bool active;
    bool write;
    bool read;
     

public:
    static const ClassId CLASS_ID= 30;
    static const MethodId METHOD_ID = 10;

    typedef boost::shared_ptr<AccessRequestBody> shared_ptr;

	// Constructors and destructors

    AccessRequestBody(ProtocolVersion version,
        const string& realm,
        bool exclusive,
        bool passive,
        bool active,
        bool write,
        bool read
        ) : AMQRequestBody(version), 
        realm(realm),
        exclusive(exclusive),
        passive(passive),
        active(active),
        write(write),
        read(read)
    { }


    AccessRequestBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~AccessRequestBody() {}
    
    // Attribute get methods

    const string& getRealm() { return realm; }
    bool getExclusive() { return exclusive; }
    bool getPassive() { return passive; }
    bool getActive() { return active; }
    bool getWrite() { return write; }
    bool getRead() { return read; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "AccessRequest: ";
        out << "realm=" << realm;
        out << "; exclusive=" << exclusive;
        out << "; passive=" << passive;
        out << "; active=" << active;
        out << "; write=" << write;
        out << "; read=" << read;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1 + realm.length(); /* realm: shortstr */
        sz += 1; /* Combinded bits: [exclusive, passive, active, write, read] */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShortString(realm); /* realm: shortstr */
        u_int8_t flags_5[1] = {0};
        flags_5[0] |= exclusive << 0; /* exclusive: bit */
        flags_5[0] |= passive << 1; /* passive: bit */
        flags_5[0] |= active << 2; /* active: bit */
        flags_5[0] |= write << 3; /* write: bit */
        flags_5[0] |= read << 4; /* read: bit */
        buffer.putOctet(flags_5[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getShortString(realm); /* realm: shortstr */
        u_int8_t flags_5[1];
        flags_5[0] = buffer.getOctet();
        exclusive = (1 << 0) & flags_5[0]; /* exclusive: bit */
        passive = (1 << 1) & flags_5[0]; /* passive: bit */
        active = (1 << 2) & flags_5[0]; /* active: bit */
        write = (1 << 3) & flags_5[0]; /* write: bit */
        read = (1 << 4) & flags_5[0]; /* read: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getAccessHandler()->request(context,
                    realm,
                    exclusive,
                    passive,
                    active,
                    write,
                    read
                    );
    }


}; // class AccessRequestBody


} // namespace framing
} // namespace qpid

#endif

