/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_BasicAckBody__
#define qpid_framing_BasicAckBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class BasicAckBody : public AMQRequestBody
{

        // Method field declarations

    u_int64_t deliveryTag;
    bool multiple;
     

public:
    static const ClassId CLASS_ID= 60;
    static const MethodId METHOD_ID = 80;

    typedef boost::shared_ptr<BasicAckBody> shared_ptr;

	// Constructors and destructors

    BasicAckBody(ProtocolVersion version,
        u_int64_t deliveryTag,
        bool multiple
        ) : AMQRequestBody(version), 
        deliveryTag(deliveryTag),
        multiple(multiple)
    { }


    BasicAckBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~BasicAckBody() {}
    
    // Attribute get methods

    u_int64_t getDeliveryTag() { return deliveryTag; }
    bool getMultiple() { return multiple; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "BasicAck: ";
        out << "deliveryTag=" << deliveryTag;
        out << "; multiple=" << multiple;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 8; /* deliveryTag: longlong */
        sz += 1; /* multiple: bit */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putLongLong(deliveryTag); /* deliveryTag: longlong */
        u_int8_t flags_1[1] = {0};
        flags_1[0] |= multiple << 0; /* multiple: bit */
        buffer.putOctet(flags_1[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        deliveryTag = buffer.getLongLong(); /* deliveryTag: longlong */
        u_int8_t flags_1[1];
        flags_1[0] = buffer.getOctet();
        multiple = (1 << 0) & flags_1[0]; /* multiple: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getBasicHandler()->ack(context,
                    deliveryTag,
                    multiple
                    );
    }


}; // class BasicAckBody


} // namespace framing
} // namespace qpid

#endif

