/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_BasicGetOkBody__
#define qpid_framing_BasicGetOkBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class BasicGetOkBody : public AMQResponseBody
{

        // Method field declarations

    u_int64_t deliveryTag;
    bool redelivered;
    string exchange;
    string routingKey;
    u_int32_t messageCount;
     

public:
    static const ClassId CLASS_ID= 60;
    static const MethodId METHOD_ID = 71;

    typedef boost::shared_ptr<BasicGetOkBody> shared_ptr;

	// Constructors and destructors

    BasicGetOkBody(ProtocolVersion version,
        RequestId toRequest,
        u_int64_t deliveryTag,
        bool redelivered,
        const string& exchange,
        const string& routingKey,
        u_int32_t messageCount
        ) : AMQResponseBody(version, 0, toRequest), 
        deliveryTag(deliveryTag),
        redelivered(redelivered),
        exchange(exchange),
        routingKey(routingKey),
        messageCount(messageCount)
    { }


    BasicGetOkBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~BasicGetOkBody() {}
    
    // Attribute get methods

    u_int64_t getDeliveryTag() { return deliveryTag; }
    bool getRedelivered() { return redelivered; }
    const string& getExchange() { return exchange; }
    const string& getRoutingKey() { return routingKey; }
    u_int32_t getMessageCount() { return messageCount; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "BasicGetOk: ";
        out << "deliveryTag=" << deliveryTag;
        out << "; redelivered=" << redelivered;
        out << "; exchange=" << exchange;
        out << "; routingKey=" << routingKey;
        out << "; messageCount=" << messageCount;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 8; /* deliveryTag: longlong */
        sz += 1; /* redelivered: bit */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1 + routingKey.length(); /* routingKey: shortstr */
        sz += 4; /* messageCount: long */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putLongLong(deliveryTag); /* deliveryTag: longlong */
        u_int8_t flags_2[1] = {0};
        flags_2[0] |= redelivered << 0; /* redelivered: bit */
        buffer.putOctet(flags_2[0]);
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
        buffer.putLong(messageCount); /* messageCount: long */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        deliveryTag = buffer.getLongLong(); /* deliveryTag: longlong */
        u_int8_t flags_2[1];
        flags_2[0] = buffer.getOctet();
        redelivered = (1 << 0) & flags_2[0]; /* redelivered: bit */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
        messageCount = buffer.getLong(); /* messageCount: long */
    }       



}; // class BasicGetOkBody


} // namespace framing
} // namespace qpid

#endif

