/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ChannelFlowOkBody__
#define qpid_framing_ChannelFlowOkBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ChannelFlowOkBody : public AMQResponseBody
{

        // Method field declarations

    bool active;
     

public:
    static const ClassId CLASS_ID= 20;
    static const MethodId METHOD_ID = 21;

    typedef boost::shared_ptr<ChannelFlowOkBody> shared_ptr;

	// Constructors and destructors

    ChannelFlowOkBody(ProtocolVersion version,
        RequestId toRequest,
        bool active
        ) : AMQResponseBody(version, 0, toRequest), 
        active(active)
    { }


    ChannelFlowOkBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~ChannelFlowOkBody() {}
    
    // Attribute get methods

    bool getActive() { return active; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ChannelFlowOk: ";
        out << "active=" << active;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1; /* active: bit */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        u_int8_t flags_0[1] = {0};
        flags_0[0] |= active << 0; /* active: bit */
        buffer.putOctet(flags_0[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        u_int8_t flags_0[1];
        flags_0[0] = buffer.getOctet();
        active = (1 << 0) & flags_0[0]; /* active: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getChannelHandler()->flowOk(context,
                    active
                    );
    }


}; // class ChannelFlowOkBody


} // namespace framing
} // namespace qpid

#endif

