/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ChannelResumeBody__
#define qpid_framing_ChannelResumeBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ChannelResumeBody : public AMQRequestBody
{

        // Method field declarations

    string channelId;
     

public:
    static const ClassId CLASS_ID= 20;
    static const MethodId METHOD_ID = 50;

    typedef boost::shared_ptr<ChannelResumeBody> shared_ptr;

	// Constructors and destructors

    ChannelResumeBody(ProtocolVersion version,
        const string& channelId
        ) : AMQRequestBody(version), 
        channelId(channelId)
    { }


    ChannelResumeBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~ChannelResumeBody() {}
    
    // Attribute get methods

    const string& getChannelId() { return channelId; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ChannelResume: ";
        out << "channelId=" << channelId;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 4 + channelId.length(); /* channelId: longstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putLongString(channelId); /* channelId: longstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getLongString(channelId); /* channelId: longstr */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getChannelHandler()->resume(context,
                    channelId
                    );
    }


}; // class ChannelResumeBody


} // namespace framing
} // namespace qpid

#endif

