/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ConnectionOpenBody__
#define qpid_framing_ConnectionOpenBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ConnectionOpenBody : public AMQRequestBody
{

        // Method field declarations

    string virtualHost;
    string capabilities;
    bool insist;
     

public:
    static const ClassId CLASS_ID= 10;
    static const MethodId METHOD_ID = 40;

    typedef boost::shared_ptr<ConnectionOpenBody> shared_ptr;

	// Constructors and destructors

    ConnectionOpenBody(ProtocolVersion version,
        const string& virtualHost,
        const string& capabilities,
        bool insist
        ) : AMQRequestBody(version), 
        virtualHost(virtualHost),
        capabilities(capabilities),
        insist(insist)
    { }


    ConnectionOpenBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~ConnectionOpenBody() {}
    
    // Attribute get methods

    const string& getVirtualHost() { return virtualHost; }
    const string& getCapabilities() { return capabilities; }
    bool getInsist() { return insist; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ConnectionOpen: ";
        out << "virtualHost=" << virtualHost;
        out << "; capabilities=" << capabilities;
        out << "; insist=" << insist;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1 + virtualHost.length(); /* virtualHost: shortstr */
        sz += 1 + capabilities.length(); /* capabilities: shortstr */
        sz += 1; /* insist: bit */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShortString(virtualHost); /* virtualHost: shortstr */
        buffer.putShortString(capabilities); /* capabilities: shortstr */
        u_int8_t flags_2[1] = {0};
        flags_2[0] |= insist << 0; /* insist: bit */
        buffer.putOctet(flags_2[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getShortString(virtualHost); /* virtualHost: shortstr */
        buffer.getShortString(capabilities); /* capabilities: shortstr */
        u_int8_t flags_2[1];
        flags_2[0] = buffer.getOctet();
        insist = (1 << 0) & flags_2[0]; /* insist: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getConnectionHandler()->open(context,
                    virtualHost,
                    capabilities,
                    insist
                    );
    }


}; // class ConnectionOpenBody


} // namespace framing
} // namespace qpid

#endif

