/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ConnectionSecureOkBody__
#define qpid_framing_ConnectionSecureOkBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ConnectionSecureOkBody : public AMQResponseBody
{

        // Method field declarations

    string response;
     

public:
    static const ClassId CLASS_ID= 10;
    static const MethodId METHOD_ID = 21;

    typedef boost::shared_ptr<ConnectionSecureOkBody> shared_ptr;

	// Constructors and destructors

    ConnectionSecureOkBody(ProtocolVersion version,
        RequestId toRequest,
        const string& response
        ) : AMQResponseBody(version, 0, toRequest), 
        response(response)
    { }


    ConnectionSecureOkBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~ConnectionSecureOkBody() {}
    
    // Attribute get methods

    const string& getResponse() { return response; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ConnectionSecureOk: ";
        out << "response=" << response;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 4 + response.length(); /* response: longstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putLongString(response); /* response: longstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getLongString(response); /* response: longstr */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getConnectionHandler()->secureOk(context,
                    response
                    );
    }


}; // class ConnectionSecureOkBody


} // namespace framing
} // namespace qpid

#endif

