/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ConnectionStartBody__
#define qpid_framing_ConnectionStartBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ConnectionStartBody : public AMQRequestBody
{

        // Method field declarations

    u_int8_t versionMajor;
    u_int8_t versionMinor;
    FieldTable serverProperties;
    string mechanisms;
    string locales;
     

public:
    static const ClassId CLASS_ID= 10;
    static const MethodId METHOD_ID = 10;

    typedef boost::shared_ptr<ConnectionStartBody> shared_ptr;

	// Constructors and destructors

    ConnectionStartBody(ProtocolVersion version,
        u_int8_t versionMajor,
        u_int8_t versionMinor,
        const FieldTable& serverProperties,
        const string& mechanisms,
        const string& locales
        ) : AMQRequestBody(version), 
        versionMajor(versionMajor),
        versionMinor(versionMinor),
        serverProperties(serverProperties),
        mechanisms(mechanisms),
        locales(locales)
    { }


    ConnectionStartBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~ConnectionStartBody() {}
    
    // Attribute get methods

    u_int8_t getVersionMajor() { return versionMajor; }
    u_int8_t getVersionMinor() { return versionMinor; }
    const FieldTable& getServerProperties() { return serverProperties; }
    const string& getMechanisms() { return mechanisms; }
    const string& getLocales() { return locales; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ConnectionStart: ";
        out << "versionMajor=" << (int)versionMajor;
        out << "; versionMinor=" << (int)versionMinor;
        out << "; serverProperties=" << serverProperties;
        out << "; mechanisms=" << mechanisms;
        out << "; locales=" << locales;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1; /* versionMajor: octet */
        sz += 1; /* versionMinor: octet */
        sz += serverProperties.size(); /* serverProperties: table */
        sz += 4 + mechanisms.length(); /* mechanisms: longstr */
        sz += 4 + locales.length(); /* locales: longstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putOctet(versionMajor); /* versionMajor: octet */
        buffer.putOctet(versionMinor); /* versionMinor: octet */
        buffer.putFieldTable(serverProperties); /* serverProperties: table */
        buffer.putLongString(mechanisms); /* mechanisms: longstr */
        buffer.putLongString(locales); /* locales: longstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        versionMajor = buffer.getOctet(); /* versionMajor: octet */
        versionMinor = buffer.getOctet(); /* versionMinor: octet */
        buffer.getFieldTable(serverProperties); /* serverProperties: table */
        buffer.getLongString(mechanisms); /* mechanisms: longstr */
        buffer.getLongString(locales); /* locales: longstr */
    }       



}; // class ConnectionStartBody


} // namespace framing
} // namespace qpid

#endif

