/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ConnectionStartOkBody__
#define qpid_framing_ConnectionStartOkBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ConnectionStartOkBody : public AMQResponseBody
{

        // Method field declarations

    FieldTable clientProperties;
    string mechanism;
    string response;
    string locale;
     

public:
    static const ClassId CLASS_ID= 10;
    static const MethodId METHOD_ID = 11;

    typedef boost::shared_ptr<ConnectionStartOkBody> shared_ptr;

	// Constructors and destructors

    ConnectionStartOkBody(ProtocolVersion version,
        RequestId toRequest,
        const FieldTable& clientProperties,
        const string& mechanism,
        const string& response,
        const string& locale
        ) : AMQResponseBody(version, 0, toRequest), 
        clientProperties(clientProperties),
        mechanism(mechanism),
        response(response),
        locale(locale)
    { }


    ConnectionStartOkBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~ConnectionStartOkBody() {}
    
    // Attribute get methods

    const FieldTable& getClientProperties() { return clientProperties; }
    const string& getMechanism() { return mechanism; }
    const string& getResponse() { return response; }
    const string& getLocale() { return locale; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ConnectionStartOk: ";
        out << "clientProperties=" << clientProperties;
        out << "; mechanism=" << mechanism;
        out << "; response=" << response;
        out << "; locale=" << locale;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += clientProperties.size(); /* clientProperties: table */
        sz += 1 + mechanism.length(); /* mechanism: shortstr */
        sz += 4 + response.length(); /* response: longstr */
        sz += 1 + locale.length(); /* locale: shortstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putFieldTable(clientProperties); /* clientProperties: table */
        buffer.putShortString(mechanism); /* mechanism: shortstr */
        buffer.putLongString(response); /* response: longstr */
        buffer.putShortString(locale); /* locale: shortstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getFieldTable(clientProperties); /* clientProperties: table */
        buffer.getShortString(mechanism); /* mechanism: shortstr */
        buffer.getLongString(response); /* response: longstr */
        buffer.getShortString(locale); /* locale: shortstr */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getConnectionHandler()->startOk(context,
                    clientProperties,
                    mechanism,
                    response,
                    locale
                    );
    }


}; // class ConnectionStartOkBody


} // namespace framing
} // namespace qpid

#endif

