/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ConnectionTuneOkBody__
#define qpid_framing_ConnectionTuneOkBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ConnectionTuneOkBody : public AMQResponseBody
{

        // Method field declarations

    u_int16_t channelMax;
    u_int32_t frameMax;
    u_int16_t heartbeat;
     

public:
    static const ClassId CLASS_ID= 10;
    static const MethodId METHOD_ID = 31;

    typedef boost::shared_ptr<ConnectionTuneOkBody> shared_ptr;

	// Constructors and destructors

    ConnectionTuneOkBody(ProtocolVersion version,
        RequestId toRequest,
        u_int16_t channelMax,
        u_int32_t frameMax,
        u_int16_t heartbeat
        ) : AMQResponseBody(version, 0, toRequest), 
        channelMax(channelMax),
        frameMax(frameMax),
        heartbeat(heartbeat)
    { }


    ConnectionTuneOkBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~ConnectionTuneOkBody() {}
    
    // Attribute get methods

    u_int16_t getChannelMax() { return channelMax; }
    u_int32_t getFrameMax() { return frameMax; }
    u_int16_t getHeartbeat() { return heartbeat; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ConnectionTuneOk: ";
        out << "channelMax=" << channelMax;
        out << "; frameMax=" << frameMax;
        out << "; heartbeat=" << heartbeat;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* channelMax: short */
        sz += 4; /* frameMax: long */
        sz += 2; /* heartbeat: short */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(channelMax); /* channelMax: short */
        buffer.putLong(frameMax); /* frameMax: long */
        buffer.putShort(heartbeat); /* heartbeat: short */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        channelMax = buffer.getShort(); /* channelMax: short */
        frameMax = buffer.getLong(); /* frameMax: long */
        heartbeat = buffer.getShort(); /* heartbeat: short */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getConnectionHandler()->tuneOk(context,
                    channelMax,
                    frameMax,
                    heartbeat
                    );
    }


}; // class ConnectionTuneOkBody


} // namespace framing
} // namespace qpid

#endif

