/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ExchangeDeclareBody__
#define qpid_framing_ExchangeDeclareBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ExchangeDeclareBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string exchange;
    string type;
    bool passive;
    bool durable;
    bool autoDelete;
    bool internal;
    bool nowait;
    FieldTable arguments;
     

public:
    static const ClassId CLASS_ID= 40;
    static const MethodId METHOD_ID = 10;

    typedef boost::shared_ptr<ExchangeDeclareBody> shared_ptr;

	// Constructors and destructors

    ExchangeDeclareBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& exchange,
        const string& type,
        bool passive,
        bool durable,
        bool autoDelete,
        bool internal,
        bool nowait,
        const FieldTable& arguments
        ) : AMQRequestBody(version), 
        ticket(ticket),
        exchange(exchange),
        type(type),
        passive(passive),
        durable(durable),
        autoDelete(autoDelete),
        internal(internal),
        nowait(nowait),
        arguments(arguments)
    { }


    ExchangeDeclareBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~ExchangeDeclareBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getExchange() { return exchange; }
    const string& getType() { return type; }
    bool getPassive() { return passive; }
    bool getDurable() { return durable; }
    bool getAutoDelete() { return autoDelete; }
    bool getInternal() { return internal; }
    bool getNowait() { return nowait; }
    const FieldTable& getArguments() { return arguments; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ExchangeDeclare: ";
        out << "ticket=" << ticket;
        out << "; exchange=" << exchange;
        out << "; type=" << type;
        out << "; passive=" << passive;
        out << "; durable=" << durable;
        out << "; autoDelete=" << autoDelete;
        out << "; internal=" << internal;
        out << "; nowait=" << nowait;
        out << "; arguments=" << arguments;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1 + type.length(); /* type: shortstr */
        sz += 1; /* Combinded bits: [passive, durable, autoDelete, internal, nowait] */
        sz += arguments.size(); /* arguments: table */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(type); /* type: shortstr */
        u_int8_t flags_8[1] = {0};
        flags_8[0] |= passive << 0; /* passive: bit */
        flags_8[0] |= durable << 1; /* durable: bit */
        flags_8[0] |= autoDelete << 2; /* autoDelete: bit */
        flags_8[0] |= internal << 3; /* internal: bit */
        flags_8[0] |= nowait << 4; /* nowait: bit */
        buffer.putOctet(flags_8[0]);
        buffer.putFieldTable(arguments); /* arguments: table */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(type); /* type: shortstr */
        u_int8_t flags_8[1];
        flags_8[0] = buffer.getOctet();
        passive = (1 << 0) & flags_8[0]; /* passive: bit */
        durable = (1 << 1) & flags_8[0]; /* durable: bit */
        autoDelete = (1 << 2) & flags_8[0]; /* autoDelete: bit */
        internal = (1 << 3) & flags_8[0]; /* internal: bit */
        nowait = (1 << 4) & flags_8[0]; /* nowait: bit */
        buffer.getFieldTable(arguments); /* arguments: table */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getExchangeHandler()->declare(context,
                    ticket,
                    exchange,
                    type,
                    passive,
                    durable,
                    autoDelete,
                    internal,
                    nowait,
                    arguments
                    );
    }


}; // class ExchangeDeclareBody


} // namespace framing
} // namespace qpid

#endif

