/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_ExchangeDeleteBody__
#define qpid_framing_ExchangeDeleteBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class ExchangeDeleteBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string exchange;
    bool ifUnused;
    bool nowait;
     

public:
    static const ClassId CLASS_ID= 40;
    static const MethodId METHOD_ID = 20;

    typedef boost::shared_ptr<ExchangeDeleteBody> shared_ptr;

	// Constructors and destructors

    ExchangeDeleteBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& exchange,
        bool ifUnused,
        bool nowait
        ) : AMQRequestBody(version), 
        ticket(ticket),
        exchange(exchange),
        ifUnused(ifUnused),
        nowait(nowait)
    { }


    ExchangeDeleteBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~ExchangeDeleteBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getExchange() { return exchange; }
    bool getIfUnused() { return ifUnused; }
    bool getNowait() { return nowait; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "ExchangeDelete: ";
        out << "ticket=" << ticket;
        out << "; exchange=" << exchange;
        out << "; ifUnused=" << ifUnused;
        out << "; nowait=" << nowait;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1; /* Combinded bits: [ifUnused, nowait] */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(exchange); /* exchange: shortstr */
        u_int8_t flags_3[1] = {0};
        flags_3[0] |= ifUnused << 0; /* ifUnused: bit */
        flags_3[0] |= nowait << 1; /* nowait: bit */
        buffer.putOctet(flags_3[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(exchange); /* exchange: shortstr */
        u_int8_t flags_3[1];
        flags_3[0] = buffer.getOctet();
        ifUnused = (1 << 0) & flags_3[0]; /* ifUnused: bit */
        nowait = (1 << 1) & flags_3[0]; /* nowait: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getExchangeHandler()->delete_(context,
                    ticket,
                    exchange,
                    ifUnused,
                    nowait
                    );
    }


}; // class ExchangeDeleteBody


} // namespace framing
} // namespace qpid

#endif

