/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_FileCancelBody__
#define qpid_framing_FileCancelBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class FileCancelBody : public AMQRequestBody
{

        // Method field declarations

    string consumerTag;
    bool nowait;
     

public:
    static const ClassId CLASS_ID= 70;
    static const MethodId METHOD_ID = 30;

    typedef boost::shared_ptr<FileCancelBody> shared_ptr;

	// Constructors and destructors

    FileCancelBody(ProtocolVersion version,
        const string& consumerTag,
        bool nowait
        ) : AMQRequestBody(version), 
        consumerTag(consumerTag),
        nowait(nowait)
    { }


    FileCancelBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~FileCancelBody() {}
    
    // Attribute get methods

    const string& getConsumerTag() { return consumerTag; }
    bool getNowait() { return nowait; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "FileCancel: ";
        out << "consumerTag=" << consumerTag;
        out << "; nowait=" << nowait;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1 + consumerTag.length(); /* consumerTag: shortstr */
        sz += 1; /* nowait: bit */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShortString(consumerTag); /* consumerTag: shortstr */
        u_int8_t flags_1[1] = {0};
        flags_1[0] |= nowait << 0; /* nowait: bit */
        buffer.putOctet(flags_1[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getShortString(consumerTag); /* consumerTag: shortstr */
        u_int8_t flags_1[1];
        flags_1[0] = buffer.getOctet();
        nowait = (1 << 0) & flags_1[0]; /* nowait: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getFileHandler()->cancel(context,
                    consumerTag,
                    nowait
                    );
    }


}; // class FileCancelBody


} // namespace framing
} // namespace qpid

#endif

