/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_FileDeliverBody__
#define qpid_framing_FileDeliverBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class FileDeliverBody : public AMQRequestBody
{

        // Method field declarations

    string consumerTag;
    u_int64_t deliveryTag;
    bool redelivered;
    string exchange;
    string routingKey;
    string identifier;
     

public:
    static const ClassId CLASS_ID= 70;
    static const MethodId METHOD_ID = 80;

    typedef boost::shared_ptr<FileDeliverBody> shared_ptr;

	// Constructors and destructors

    FileDeliverBody(ProtocolVersion version,
        const string& consumerTag,
        u_int64_t deliveryTag,
        bool redelivered,
        const string& exchange,
        const string& routingKey,
        const string& identifier
        ) : AMQRequestBody(version), 
        consumerTag(consumerTag),
        deliveryTag(deliveryTag),
        redelivered(redelivered),
        exchange(exchange),
        routingKey(routingKey),
        identifier(identifier)
    { }


    FileDeliverBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~FileDeliverBody() {}
    
    // Attribute get methods

    const string& getConsumerTag() { return consumerTag; }
    u_int64_t getDeliveryTag() { return deliveryTag; }
    bool getRedelivered() { return redelivered; }
    const string& getExchange() { return exchange; }
    const string& getRoutingKey() { return routingKey; }
    const string& getIdentifier() { return identifier; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "FileDeliver: ";
        out << "consumerTag=" << consumerTag;
        out << "; deliveryTag=" << deliveryTag;
        out << "; redelivered=" << redelivered;
        out << "; exchange=" << exchange;
        out << "; routingKey=" << routingKey;
        out << "; identifier=" << identifier;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1 + consumerTag.length(); /* consumerTag: shortstr */
        sz += 8; /* deliveryTag: longlong */
        sz += 1; /* redelivered: bit */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1 + routingKey.length(); /* routingKey: shortstr */
        sz += 1 + identifier.length(); /* identifier: shortstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShortString(consumerTag); /* consumerTag: shortstr */
        buffer.putLongLong(deliveryTag); /* deliveryTag: longlong */
        u_int8_t flags_3[1] = {0};
        flags_3[0] |= redelivered << 0; /* redelivered: bit */
        buffer.putOctet(flags_3[0]);
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
        buffer.putShortString(identifier); /* identifier: shortstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getShortString(consumerTag); /* consumerTag: shortstr */
        deliveryTag = buffer.getLongLong(); /* deliveryTag: longlong */
        u_int8_t flags_3[1];
        flags_3[0] = buffer.getOctet();
        redelivered = (1 << 0) & flags_3[0]; /* redelivered: bit */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
        buffer.getShortString(identifier); /* identifier: shortstr */
    }       



}; // class FileDeliverBody


} // namespace framing
} // namespace qpid

#endif

