/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_FileOpenBody__
#define qpid_framing_FileOpenBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class FileOpenBody : public AMQRequestBody
{

        // Method field declarations

    string identifier;
    u_int64_t contentSize;
     

public:
    static const ClassId CLASS_ID= 70;
    static const MethodId METHOD_ID = 40;

    typedef boost::shared_ptr<FileOpenBody> shared_ptr;

	// Constructors and destructors

    FileOpenBody(ProtocolVersion version,
        const string& identifier,
        u_int64_t contentSize
        ) : AMQRequestBody(version), 
        identifier(identifier),
        contentSize(contentSize)
    { }


    FileOpenBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~FileOpenBody() {}
    
    // Attribute get methods

    const string& getIdentifier() { return identifier; }
    u_int64_t getContentSize() { return contentSize; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "FileOpen: ";
        out << "identifier=" << identifier;
        out << "; contentSize=" << contentSize;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1 + identifier.length(); /* identifier: shortstr */
        sz += 8; /* contentSize: longlong */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShortString(identifier); /* identifier: shortstr */
        buffer.putLongLong(contentSize); /* contentSize: longlong */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getShortString(identifier); /* identifier: shortstr */
        contentSize = buffer.getLongLong(); /* contentSize: longlong */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getFileHandler()->open(context,
                    identifier,
                    contentSize
                    );
    }


}; // class FileOpenBody


} // namespace framing
} // namespace qpid

#endif

