/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_FilePublishBody__
#define qpid_framing_FilePublishBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class FilePublishBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string exchange;
    string routingKey;
    bool mandatory;
    bool immediate;
    string identifier;
     

public:
    static const ClassId CLASS_ID= 70;
    static const MethodId METHOD_ID = 60;

    typedef boost::shared_ptr<FilePublishBody> shared_ptr;

	// Constructors and destructors

    FilePublishBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& exchange,
        const string& routingKey,
        bool mandatory,
        bool immediate,
        const string& identifier
        ) : AMQRequestBody(version), 
        ticket(ticket),
        exchange(exchange),
        routingKey(routingKey),
        mandatory(mandatory),
        immediate(immediate),
        identifier(identifier)
    { }


    FilePublishBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~FilePublishBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getExchange() { return exchange; }
    const string& getRoutingKey() { return routingKey; }
    bool getMandatory() { return mandatory; }
    bool getImmediate() { return immediate; }
    const string& getIdentifier() { return identifier; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "FilePublish: ";
        out << "ticket=" << ticket;
        out << "; exchange=" << exchange;
        out << "; routingKey=" << routingKey;
        out << "; mandatory=" << mandatory;
        out << "; immediate=" << immediate;
        out << "; identifier=" << identifier;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1 + routingKey.length(); /* routingKey: shortstr */
        sz += 1; /* Combinded bits: [mandatory, immediate] */
        sz += 1 + identifier.length(); /* identifier: shortstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
        u_int8_t flags_5[1] = {0};
        flags_5[0] |= mandatory << 0; /* mandatory: bit */
        flags_5[0] |= immediate << 1; /* immediate: bit */
        buffer.putOctet(flags_5[0]);
        buffer.putShortString(identifier); /* identifier: shortstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
        u_int8_t flags_5[1];
        flags_5[0] = buffer.getOctet();
        mandatory = (1 << 0) & flags_5[0]; /* mandatory: bit */
        immediate = (1 << 1) & flags_5[0]; /* immediate: bit */
        buffer.getShortString(identifier); /* identifier: shortstr */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getFileHandler()->publish(context,
                    ticket,
                    exchange,
                    routingKey,
                    mandatory,
                    immediate,
                    identifier
                    );
    }


}; // class FilePublishBody


} // namespace framing
} // namespace qpid

#endif

