/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_FileReturnBody__
#define qpid_framing_FileReturnBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class FileReturnBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t replyCode;
    string replyText;
    string exchange;
    string routingKey;
     

public:
    static const ClassId CLASS_ID= 70;
    static const MethodId METHOD_ID = 70;

    typedef boost::shared_ptr<FileReturnBody> shared_ptr;

	// Constructors and destructors

    FileReturnBody(ProtocolVersion version,
        u_int16_t replyCode,
        const string& replyText,
        const string& exchange,
        const string& routingKey
        ) : AMQRequestBody(version), 
        replyCode(replyCode),
        replyText(replyText),
        exchange(exchange),
        routingKey(routingKey)
    { }


    FileReturnBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~FileReturnBody() {}
    
    // Attribute get methods

    u_int16_t getReplyCode() { return replyCode; }
    const string& getReplyText() { return replyText; }
    const string& getExchange() { return exchange; }
    const string& getRoutingKey() { return routingKey; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "FileReturn: ";
        out << "replyCode=" << replyCode;
        out << "; replyText=" << replyText;
        out << "; exchange=" << exchange;
        out << "; routingKey=" << routingKey;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* replyCode: short */
        sz += 1 + replyText.length(); /* replyText: shortstr */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1 + routingKey.length(); /* routingKey: shortstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(replyCode); /* replyCode: short */
        buffer.putShortString(replyText); /* replyText: shortstr */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        replyCode = buffer.getShort(); /* replyCode: short */
        buffer.getShortString(replyText); /* replyText: shortstr */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
    }       



}; // class FileReturnBody


} // namespace framing
} // namespace qpid

#endif

