/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_MessageAppendBody__
#define qpid_framing_MessageAppendBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class MessageAppendBody : public AMQRequestBody
{

        // Method field declarations

    string reference;
    string bytes;
     

public:
    static const ClassId CLASS_ID= 120;
    static const MethodId METHOD_ID = 80;

    typedef boost::shared_ptr<MessageAppendBody> shared_ptr;

	// Constructors and destructors

    MessageAppendBody(ProtocolVersion version,
        const string& reference,
        const string& bytes
        ) : AMQRequestBody(version), 
        reference(reference),
        bytes(bytes)
    { }


    MessageAppendBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~MessageAppendBody() {}
    
    // Attribute get methods

    const string& getReference() { return reference; }
    const string& getBytes() { return bytes; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "MessageAppend: ";
        out << "reference=" << reference;
        out << "; bytes=" << bytes;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 4 + reference.length(); /* reference: longstr */
        sz += 4 + bytes.length(); /* bytes: longstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putLongString(reference); /* reference: longstr */
        buffer.putLongString(bytes); /* bytes: longstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getLongString(reference); /* reference: longstr */
        buffer.getLongString(bytes); /* bytes: longstr */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getMessageHandler()->append(context,
                    reference,
                    bytes
                    );
    }


}; // class MessageAppendBody


} // namespace framing
} // namespace qpid

#endif

