/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_MessageConsumeBody__
#define qpid_framing_MessageConsumeBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class MessageConsumeBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string queue;
    string destination;
    bool noLocal;
    bool noAck;
    bool exclusive;
    FieldTable filter;
     

public:
    static const ClassId CLASS_ID= 120;
    static const MethodId METHOD_ID = 20;

    typedef boost::shared_ptr<MessageConsumeBody> shared_ptr;

	// Constructors and destructors

    MessageConsumeBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& queue,
        const string& destination,
        bool noLocal,
        bool noAck,
        bool exclusive,
        const FieldTable& filter
        ) : AMQRequestBody(version), 
        ticket(ticket),
        queue(queue),
        destination(destination),
        noLocal(noLocal),
        noAck(noAck),
        exclusive(exclusive),
        filter(filter)
    { }


    MessageConsumeBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~MessageConsumeBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getQueue() { return queue; }
    const string& getDestination() { return destination; }
    bool getNoLocal() { return noLocal; }
    bool getNoAck() { return noAck; }
    bool getExclusive() { return exclusive; }
    const FieldTable& getFilter() { return filter; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "MessageConsume: ";
        out << "ticket=" << ticket;
        out << "; queue=" << queue;
        out << "; destination=" << destination;
        out << "; noLocal=" << noLocal;
        out << "; noAck=" << noAck;
        out << "; exclusive=" << exclusive;
        out << "; filter=" << filter;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + queue.length(); /* queue: shortstr */
        sz += 1 + destination.length(); /* destination: shortstr */
        sz += 1; /* Combinded bits: [noLocal, noAck, exclusive] */
        sz += filter.size(); /* filter: table */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(queue); /* queue: shortstr */
        buffer.putShortString(destination); /* destination: shortstr */
        u_int8_t flags_6[1] = {0};
        flags_6[0] |= noLocal << 0; /* noLocal: bit */
        flags_6[0] |= noAck << 1; /* noAck: bit */
        flags_6[0] |= exclusive << 2; /* exclusive: bit */
        buffer.putOctet(flags_6[0]);
        buffer.putFieldTable(filter); /* filter: table */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(queue); /* queue: shortstr */
        buffer.getShortString(destination); /* destination: shortstr */
        u_int8_t flags_6[1];
        flags_6[0] = buffer.getOctet();
        noLocal = (1 << 0) & flags_6[0]; /* noLocal: bit */
        noAck = (1 << 1) & flags_6[0]; /* noAck: bit */
        exclusive = (1 << 2) & flags_6[0]; /* exclusive: bit */
        buffer.getFieldTable(filter); /* filter: table */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getMessageHandler()->consume(context,
                    ticket,
                    queue,
                    destination,
                    noLocal,
                    noAck,
                    exclusive,
                    filter
                    );
    }


}; // class MessageConsumeBody


} // namespace framing
} // namespace qpid

#endif

