/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_MessageGetBody__
#define qpid_framing_MessageGetBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class MessageGetBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string queue;
    string destination;
    bool noAck;
     

public:
    static const ClassId CLASS_ID= 120;
    static const MethodId METHOD_ID = 40;

    typedef boost::shared_ptr<MessageGetBody> shared_ptr;

	// Constructors and destructors

    MessageGetBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& queue,
        const string& destination,
        bool noAck
        ) : AMQRequestBody(version), 
        ticket(ticket),
        queue(queue),
        destination(destination),
        noAck(noAck)
    { }


    MessageGetBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~MessageGetBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getQueue() { return queue; }
    const string& getDestination() { return destination; }
    bool getNoAck() { return noAck; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "MessageGet: ";
        out << "ticket=" << ticket;
        out << "; queue=" << queue;
        out << "; destination=" << destination;
        out << "; noAck=" << noAck;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + queue.length(); /* queue: shortstr */
        sz += 1 + destination.length(); /* destination: shortstr */
        sz += 1; /* noAck: bit */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(queue); /* queue: shortstr */
        buffer.putShortString(destination); /* destination: shortstr */
        u_int8_t flags_3[1] = {0};
        flags_3[0] |= noAck << 0; /* noAck: bit */
        buffer.putOctet(flags_3[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(queue); /* queue: shortstr */
        buffer.getShortString(destination); /* destination: shortstr */
        u_int8_t flags_3[1];
        flags_3[0] = buffer.getOctet();
        noAck = (1 << 0) & flags_3[0]; /* noAck: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getMessageHandler()->get(context,
                    ticket,
                    queue,
                    destination,
                    noAck
                    );
    }


}; // class MessageGetBody


} // namespace framing
} // namespace qpid

#endif

