/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_MessageRecoverBody__
#define qpid_framing_MessageRecoverBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class MessageRecoverBody : public AMQRequestBody
{

        // Method field declarations

    bool requeue;
     

public:
    static const ClassId CLASS_ID= 120;
    static const MethodId METHOD_ID = 50;

    typedef boost::shared_ptr<MessageRecoverBody> shared_ptr;

	// Constructors and destructors

    MessageRecoverBody(ProtocolVersion version,
        bool requeue
        ) : AMQRequestBody(version), 
        requeue(requeue)
    { }


    MessageRecoverBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~MessageRecoverBody() {}
    
    // Attribute get methods

    bool getRequeue() { return requeue; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "MessageRecover: ";
        out << "requeue=" << requeue;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1; /* requeue: bit */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        u_int8_t flags_0[1] = {0};
        flags_0[0] |= requeue << 0; /* requeue: bit */
        buffer.putOctet(flags_0[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        u_int8_t flags_0[1];
        flags_0[0] = buffer.getOctet();
        requeue = (1 << 0) & flags_0[0]; /* requeue: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getMessageHandler()->recover(context,
                    requeue
                    );
    }


}; // class MessageRecoverBody


} // namespace framing
} // namespace qpid

#endif

