/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_MessageRejectBody__
#define qpid_framing_MessageRejectBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class MessageRejectBody : public AMQResponseBody
{

        // Method field declarations

    u_int16_t code;
    string text;
     

public:
    static const ClassId CLASS_ID= 120;
    static const MethodId METHOD_ID = 520;

    typedef boost::shared_ptr<MessageRejectBody> shared_ptr;

	// Constructors and destructors

    MessageRejectBody(ProtocolVersion version,
        RequestId toRequest,
        u_int16_t code,
        const string& text
        ) : AMQResponseBody(version, 0, toRequest), 
        code(code),
        text(text)
    { }


    MessageRejectBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~MessageRejectBody() {}
    
    // Attribute get methods

    u_int16_t getCode() { return code; }
    const string& getText() { return text; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "MessageReject: ";
        out << "code=" << code;
        out << "; text=" << text;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* code: short */
        sz += 1 + text.length(); /* text: shortstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(code); /* code: short */
        buffer.putShortString(text); /* text: shortstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        code = buffer.getShort(); /* code: short */
        buffer.getShortString(text); /* text: shortstr */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getMessageHandler()->reject(context,
                    code,
                    text
                    );
    }


}; // class MessageRejectBody


} // namespace framing
} // namespace qpid

#endif

