/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_MessageTransferBody__
#define qpid_framing_MessageTransferBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class MessageTransferBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string destination;
    bool redelivered;
    bool immediate;
    u_int64_t ttl;
    u_int8_t priority;
    u_int64_t timestamp;
    u_int8_t deliveryMode;
    u_int64_t expiration;
    string exchange;
    string routingKey;
    string messageId;
    string correlationId;
    string replyTo;
    string contentType;
    string contentEncoding;
    string userId;
    string appId;
    string transactionId;
    string securityToken;
    FieldTable applicationHeaders;
    Content body;
    bool mandatory;
     

public:
    static const ClassId CLASS_ID= 120;
    static const MethodId METHOD_ID = 10;

    typedef boost::shared_ptr<MessageTransferBody> shared_ptr;

	// Constructors and destructors

    MessageTransferBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& destination,
        bool redelivered,
        bool immediate,
        u_int64_t ttl,
        u_int8_t priority,
        u_int64_t timestamp,
        u_int8_t deliveryMode,
        u_int64_t expiration,
        const string& exchange,
        const string& routingKey,
        const string& messageId,
        const string& correlationId,
        const string& replyTo,
        const string& contentType,
        const string& contentEncoding,
        const string& userId,
        const string& appId,
        const string& transactionId,
        const string& securityToken,
        const FieldTable& applicationHeaders,
        const Content& body,
        bool mandatory
        ) : AMQRequestBody(version), 
        ticket(ticket),
        destination(destination),
        redelivered(redelivered),
        immediate(immediate),
        ttl(ttl),
        priority(priority),
        timestamp(timestamp),
        deliveryMode(deliveryMode),
        expiration(expiration),
        exchange(exchange),
        routingKey(routingKey),
        messageId(messageId),
        correlationId(correlationId),
        replyTo(replyTo),
        contentType(contentType),
        contentEncoding(contentEncoding),
        userId(userId),
        appId(appId),
        transactionId(transactionId),
        securityToken(securityToken),
        applicationHeaders(applicationHeaders),
        body(body),
        mandatory(mandatory)
    { }


    MessageTransferBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~MessageTransferBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getDestination() { return destination; }
    bool getRedelivered() { return redelivered; }
    bool getImmediate() { return immediate; }
    u_int64_t getTtl() { return ttl; }
    u_int8_t getPriority() { return priority; }
    u_int64_t getTimestamp() { return timestamp; }
    u_int8_t getDeliveryMode() { return deliveryMode; }
    u_int64_t getExpiration() { return expiration; }
    const string& getExchange() { return exchange; }
    const string& getRoutingKey() { return routingKey; }
    const string& getMessageId() { return messageId; }
    const string& getCorrelationId() { return correlationId; }
    const string& getReplyTo() { return replyTo; }
    const string& getContentType() { return contentType; }
    const string& getContentEncoding() { return contentEncoding; }
    const string& getUserId() { return userId; }
    const string& getAppId() { return appId; }
    const string& getTransactionId() { return transactionId; }
    const string& getSecurityToken() { return securityToken; }
    const FieldTable& getApplicationHeaders() { return applicationHeaders; }
    const Content& getBody() { return body; }
    bool getMandatory() { return mandatory; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "MessageTransfer: ";
        out << "ticket=" << ticket;
        out << "; destination=" << destination;
        out << "; redelivered=" << redelivered;
        out << "; immediate=" << immediate;
        out << "; ttl=" << ttl;
        out << "; priority=" << (int)priority;
        out << "; timestamp=" << timestamp;
        out << "; deliveryMode=" << (int)deliveryMode;
        out << "; expiration=" << expiration;
        out << "; exchange=" << exchange;
        out << "; routingKey=" << routingKey;
        out << "; messageId=" << messageId;
        out << "; correlationId=" << correlationId;
        out << "; replyTo=" << replyTo;
        out << "; contentType=" << contentType;
        out << "; contentEncoding=" << contentEncoding;
        out << "; userId=" << userId;
        out << "; appId=" << appId;
        out << "; transactionId=" << transactionId;
        out << "; securityToken=" << securityToken;
        out << "; applicationHeaders=" << applicationHeaders;
        out << "; body=" << body;
        out << "; mandatory=" << mandatory;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + destination.length(); /* destination: shortstr */
        sz += 1; /* Combinded bits: [redelivered, immediate] */
        sz += 8; /* ttl: longlong */
        sz += 1; /* priority: octet */
        sz += 8; /* timestamp: timestamp */
        sz += 1; /* deliveryMode: octet */
        sz += 8; /* expiration: timestamp */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1 + routingKey.length(); /* routingKey: shortstr */
        sz += 1 + messageId.length(); /* messageId: shortstr */
        sz += 1 + correlationId.length(); /* correlationId: shortstr */
        sz += 1 + replyTo.length(); /* replyTo: shortstr */
        sz += 1 + contentType.length(); /* contentType: shortstr */
        sz += 1 + contentEncoding.length(); /* contentEncoding: shortstr */
        sz += 1 + userId.length(); /* userId: shortstr */
        sz += 1 + appId.length(); /* appId: shortstr */
        sz += 1 + transactionId.length(); /* transactionId: shortstr */
        sz += 4 + securityToken.length(); /* securityToken: longstr */
        sz += applicationHeaders.size(); /* applicationHeaders: table */
        sz += body.size(); /* body: content */
        sz += 1; /* mandatory: bit */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(destination); /* destination: shortstr */
        u_int8_t flags_4[1] = {0};
        flags_4[0] |= redelivered << 0; /* redelivered: bit */
        flags_4[0] |= immediate << 1; /* immediate: bit */
        buffer.putOctet(flags_4[0]);
        buffer.putLongLong(ttl); /* ttl: longlong */
        buffer.putOctet(priority); /* priority: octet */
        buffer.putLongLong(timestamp); /* timestamp: timestamp */
        buffer.putOctet(deliveryMode); /* deliveryMode: octet */
        buffer.putLongLong(expiration); /* expiration: timestamp */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
        buffer.putShortString(messageId); /* messageId: shortstr */
        buffer.putShortString(correlationId); /* correlationId: shortstr */
        buffer.putShortString(replyTo); /* replyTo: shortstr */
        buffer.putShortString(contentType); /* contentType: shortstr */
        buffer.putShortString(contentEncoding); /* contentEncoding: shortstr */
        buffer.putShortString(userId); /* userId: shortstr */
        buffer.putShortString(appId); /* appId: shortstr */
        buffer.putShortString(transactionId); /* transactionId: shortstr */
        buffer.putLongString(securityToken); /* securityToken: longstr */
        buffer.putFieldTable(applicationHeaders); /* applicationHeaders: table */
        buffer.putContent(body); /* body: content */
        u_int8_t flags_22[1] = {0};
        flags_22[0] |= mandatory << 0; /* mandatory: bit */
        buffer.putOctet(flags_22[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(destination); /* destination: shortstr */
        u_int8_t flags_4[1];
        flags_4[0] = buffer.getOctet();
        redelivered = (1 << 0) & flags_4[0]; /* redelivered: bit */
        immediate = (1 << 1) & flags_4[0]; /* immediate: bit */
        ttl = buffer.getLongLong(); /* ttl: longlong */
        priority = buffer.getOctet(); /* priority: octet */
        timestamp = buffer.getLongLong(); /* timestamp: timestamp */
        deliveryMode = buffer.getOctet(); /* deliveryMode: octet */
        expiration = buffer.getLongLong(); /* expiration: timestamp */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
        buffer.getShortString(messageId); /* messageId: shortstr */
        buffer.getShortString(correlationId); /* correlationId: shortstr */
        buffer.getShortString(replyTo); /* replyTo: shortstr */
        buffer.getShortString(contentType); /* contentType: shortstr */
        buffer.getShortString(contentEncoding); /* contentEncoding: shortstr */
        buffer.getShortString(userId); /* userId: shortstr */
        buffer.getShortString(appId); /* appId: shortstr */
        buffer.getShortString(transactionId); /* transactionId: shortstr */
        buffer.getLongString(securityToken); /* securityToken: longstr */
        buffer.getFieldTable(applicationHeaders); /* applicationHeaders: table */
        buffer.getContent(body); /* body: content */
        u_int8_t flags_22[1];
        flags_22[0] = buffer.getOctet();
        mandatory = (1 << 0) & flags_22[0]; /* mandatory: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getMessageHandler()->transfer(context,
                    ticket,
                    destination,
                    redelivered,
                    immediate,
                    ttl,
                    priority,
                    timestamp,
                    deliveryMode,
                    expiration,
                    exchange,
                    routingKey,
                    messageId,
                    correlationId,
                    replyTo,
                    contentType,
                    contentEncoding,
                    userId,
                    appId,
                    transactionId,
                    securityToken,
                    applicationHeaders,
                    body,
                    mandatory
                    );
    }


}; // class MessageTransferBody


} // namespace framing
} // namespace qpid

#endif

