/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_QueueBindBody__
#define qpid_framing_QueueBindBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class QueueBindBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string queue;
    string exchange;
    string routingKey;
    bool nowait;
    FieldTable arguments;
     

public:
    static const ClassId CLASS_ID= 50;
    static const MethodId METHOD_ID = 20;

    typedef boost::shared_ptr<QueueBindBody> shared_ptr;

	// Constructors and destructors

    QueueBindBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& queue,
        const string& exchange,
        const string& routingKey,
        bool nowait,
        const FieldTable& arguments
        ) : AMQRequestBody(version), 
        ticket(ticket),
        queue(queue),
        exchange(exchange),
        routingKey(routingKey),
        nowait(nowait),
        arguments(arguments)
    { }


    QueueBindBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~QueueBindBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getQueue() { return queue; }
    const string& getExchange() { return exchange; }
    const string& getRoutingKey() { return routingKey; }
    bool getNowait() { return nowait; }
    const FieldTable& getArguments() { return arguments; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "QueueBind: ";
        out << "ticket=" << ticket;
        out << "; queue=" << queue;
        out << "; exchange=" << exchange;
        out << "; routingKey=" << routingKey;
        out << "; nowait=" << nowait;
        out << "; arguments=" << arguments;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + queue.length(); /* queue: shortstr */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1 + routingKey.length(); /* routingKey: shortstr */
        sz += 1; /* nowait: bit */
        sz += arguments.size(); /* arguments: table */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(queue); /* queue: shortstr */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
        u_int8_t flags_5[1] = {0};
        flags_5[0] |= nowait << 0; /* nowait: bit */
        buffer.putOctet(flags_5[0]);
        buffer.putFieldTable(arguments); /* arguments: table */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(queue); /* queue: shortstr */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
        u_int8_t flags_5[1];
        flags_5[0] = buffer.getOctet();
        nowait = (1 << 0) & flags_5[0]; /* nowait: bit */
        buffer.getFieldTable(arguments); /* arguments: table */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getQueueHandler()->bind(context,
                    ticket,
                    queue,
                    exchange,
                    routingKey,
                    nowait,
                    arguments
                    );
    }


}; // class QueueBindBody


} // namespace framing
} // namespace qpid

#endif

