/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_QueueDeclareBody__
#define qpid_framing_QueueDeclareBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class QueueDeclareBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string queue;
    bool passive;
    bool durable;
    bool exclusive;
    bool autoDelete;
    bool nowait;
    FieldTable arguments;
     

public:
    static const ClassId CLASS_ID= 50;
    static const MethodId METHOD_ID = 10;

    typedef boost::shared_ptr<QueueDeclareBody> shared_ptr;

	// Constructors and destructors

    QueueDeclareBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& queue,
        bool passive,
        bool durable,
        bool exclusive,
        bool autoDelete,
        bool nowait,
        const FieldTable& arguments
        ) : AMQRequestBody(version), 
        ticket(ticket),
        queue(queue),
        passive(passive),
        durable(durable),
        exclusive(exclusive),
        autoDelete(autoDelete),
        nowait(nowait),
        arguments(arguments)
    { }


    QueueDeclareBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~QueueDeclareBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getQueue() { return queue; }
    bool getPassive() { return passive; }
    bool getDurable() { return durable; }
    bool getExclusive() { return exclusive; }
    bool getAutoDelete() { return autoDelete; }
    bool getNowait() { return nowait; }
    const FieldTable& getArguments() { return arguments; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "QueueDeclare: ";
        out << "ticket=" << ticket;
        out << "; queue=" << queue;
        out << "; passive=" << passive;
        out << "; durable=" << durable;
        out << "; exclusive=" << exclusive;
        out << "; autoDelete=" << autoDelete;
        out << "; nowait=" << nowait;
        out << "; arguments=" << arguments;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + queue.length(); /* queue: shortstr */
        sz += 1; /* Combinded bits: [passive, durable, exclusive, autoDelete, nowait] */
        sz += arguments.size(); /* arguments: table */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(queue); /* queue: shortstr */
        u_int8_t flags_7[1] = {0};
        flags_7[0] |= passive << 0; /* passive: bit */
        flags_7[0] |= durable << 1; /* durable: bit */
        flags_7[0] |= exclusive << 2; /* exclusive: bit */
        flags_7[0] |= autoDelete << 3; /* autoDelete: bit */
        flags_7[0] |= nowait << 4; /* nowait: bit */
        buffer.putOctet(flags_7[0]);
        buffer.putFieldTable(arguments); /* arguments: table */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(queue); /* queue: shortstr */
        u_int8_t flags_7[1];
        flags_7[0] = buffer.getOctet();
        passive = (1 << 0) & flags_7[0]; /* passive: bit */
        durable = (1 << 1) & flags_7[0]; /* durable: bit */
        exclusive = (1 << 2) & flags_7[0]; /* exclusive: bit */
        autoDelete = (1 << 3) & flags_7[0]; /* autoDelete: bit */
        nowait = (1 << 4) & flags_7[0]; /* nowait: bit */
        buffer.getFieldTable(arguments); /* arguments: table */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getQueueHandler()->declare(context,
                    ticket,
                    queue,
                    passive,
                    durable,
                    exclusive,
                    autoDelete,
                    nowait,
                    arguments
                    );
    }


}; // class QueueDeclareBody


} // namespace framing
} // namespace qpid

#endif

