/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_QueueDeclareOkBody__
#define qpid_framing_QueueDeclareOkBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class QueueDeclareOkBody : public AMQResponseBody
{

        // Method field declarations

    string queue;
    u_int32_t messageCount;
    u_int32_t consumerCount;
     

public:
    static const ClassId CLASS_ID= 50;
    static const MethodId METHOD_ID = 11;

    typedef boost::shared_ptr<QueueDeclareOkBody> shared_ptr;

	// Constructors and destructors

    QueueDeclareOkBody(ProtocolVersion version,
        RequestId toRequest,
        const string& queue,
        u_int32_t messageCount,
        u_int32_t consumerCount
        ) : AMQResponseBody(version, 0, toRequest), 
        queue(queue),
        messageCount(messageCount),
        consumerCount(consumerCount)
    { }


    QueueDeclareOkBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~QueueDeclareOkBody() {}
    
    // Attribute get methods

    const string& getQueue() { return queue; }
    u_int32_t getMessageCount() { return messageCount; }
    u_int32_t getConsumerCount() { return consumerCount; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "QueueDeclareOk: ";
        out << "queue=" << queue;
        out << "; messageCount=" << messageCount;
        out << "; consumerCount=" << consumerCount;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1 + queue.length(); /* queue: shortstr */
        sz += 4; /* messageCount: long */
        sz += 4; /* consumerCount: long */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShortString(queue); /* queue: shortstr */
        buffer.putLong(messageCount); /* messageCount: long */
        buffer.putLong(consumerCount); /* consumerCount: long */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getShortString(queue); /* queue: shortstr */
        messageCount = buffer.getLong(); /* messageCount: long */
        consumerCount = buffer.getLong(); /* consumerCount: long */
    }       



}; // class QueueDeclareOkBody


} // namespace framing
} // namespace qpid

#endif

