/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_QueueDeleteBody__
#define qpid_framing_QueueDeleteBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class QueueDeleteBody : public AMQRequestBody
{

        // Method field declarations

    u_int16_t ticket;
    string queue;
    bool ifUnused;
    bool ifEmpty;
    bool nowait;
     

public:
    static const ClassId CLASS_ID= 50;
    static const MethodId METHOD_ID = 40;

    typedef boost::shared_ptr<QueueDeleteBody> shared_ptr;

	// Constructors and destructors

    QueueDeleteBody(ProtocolVersion version,
        u_int16_t ticket,
        const string& queue,
        bool ifUnused,
        bool ifEmpty,
        bool nowait
        ) : AMQRequestBody(version), 
        ticket(ticket),
        queue(queue),
        ifUnused(ifUnused),
        ifEmpty(ifEmpty),
        nowait(nowait)
    { }


    QueueDeleteBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~QueueDeleteBody() {}
    
    // Attribute get methods

    u_int16_t getTicket() { return ticket; }
    const string& getQueue() { return queue; }
    bool getIfUnused() { return ifUnused; }
    bool getIfEmpty() { return ifEmpty; }
    bool getNowait() { return nowait; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "QueueDelete: ";
        out << "ticket=" << ticket;
        out << "; queue=" << queue;
        out << "; ifUnused=" << ifUnused;
        out << "; ifEmpty=" << ifEmpty;
        out << "; nowait=" << nowait;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 2; /* ticket: short */
        sz += 1 + queue.length(); /* queue: shortstr */
        sz += 1; /* Combinded bits: [ifUnused, ifEmpty, nowait] */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(queue); /* queue: shortstr */
        u_int8_t flags_4[1] = {0};
        flags_4[0] |= ifUnused << 0; /* ifUnused: bit */
        flags_4[0] |= ifEmpty << 1; /* ifEmpty: bit */
        flags_4[0] |= nowait << 2; /* nowait: bit */
        buffer.putOctet(flags_4[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(queue); /* queue: shortstr */
        u_int8_t flags_4[1];
        flags_4[0] = buffer.getOctet();
        ifUnused = (1 << 0) & flags_4[0]; /* ifUnused: bit */
        ifEmpty = (1 << 1) & flags_4[0]; /* ifEmpty: bit */
        nowait = (1 << 2) & flags_4[0]; /* nowait: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getQueueHandler()->delete_(context,
                    ticket,
                    queue,
                    ifUnused,
                    ifEmpty,
                    nowait
                    );
    }


}; // class QueueDeleteBody


} // namespace framing
} // namespace qpid

#endif

