/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_QueuePurgeOkBody__
#define qpid_framing_QueuePurgeOkBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class QueuePurgeOkBody : public AMQResponseBody
{

        // Method field declarations

    u_int32_t messageCount;
     

public:
    static const ClassId CLASS_ID= 50;
    static const MethodId METHOD_ID = 31;

    typedef boost::shared_ptr<QueuePurgeOkBody> shared_ptr;

	// Constructors and destructors

    QueuePurgeOkBody(ProtocolVersion version,
        RequestId toRequest,
        u_int32_t messageCount
        ) : AMQResponseBody(version, 0, toRequest), 
        messageCount(messageCount)
    { }


    QueuePurgeOkBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~QueuePurgeOkBody() {}
    
    // Attribute get methods

    u_int32_t getMessageCount() { return messageCount; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "QueuePurgeOk: ";
        out << "messageCount=" << messageCount;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 4; /* messageCount: long */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putLong(messageCount); /* messageCount: long */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        messageCount = buffer.getLong(); /* messageCount: long */
    }       



}; // class QueuePurgeOkBody


} // namespace framing
} // namespace qpid

#endif

