/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_StreamCancelOkBody__
#define qpid_framing_StreamCancelOkBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQResponseBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class StreamCancelOkBody : public AMQResponseBody
{

        // Method field declarations

    string consumerTag;
     

public:
    static const ClassId CLASS_ID= 80;
    static const MethodId METHOD_ID = 31;

    typedef boost::shared_ptr<StreamCancelOkBody> shared_ptr;

	// Constructors and destructors

    StreamCancelOkBody(ProtocolVersion version,
        RequestId toRequest,
        const string& consumerTag
        ) : AMQResponseBody(version, 0, toRequest), 
        consumerTag(consumerTag)
    { }


    StreamCancelOkBody(ProtocolVersion version): AMQResponseBody(version) {}
    virtual ~StreamCancelOkBody() {}
    
    // Attribute get methods

    const string& getConsumerTag() { return consumerTag; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "StreamCancelOk: ";
        out << "consumerTag=" << consumerTag;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1 + consumerTag.length(); /* consumerTag: shortstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShortString(consumerTag); /* consumerTag: shortstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getShortString(consumerTag); /* consumerTag: shortstr */
    }       



}; // class StreamCancelOkBody


} // namespace framing
} // namespace qpid

#endif

