/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_StreamDeliverBody__
#define qpid_framing_StreamDeliverBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class StreamDeliverBody : public AMQRequestBody
{

        // Method field declarations

    string consumerTag;
    u_int64_t deliveryTag;
    string exchange;
    string queue;
     

public:
    static const ClassId CLASS_ID= 80;
    static const MethodId METHOD_ID = 60;

    typedef boost::shared_ptr<StreamDeliverBody> shared_ptr;

	// Constructors and destructors

    StreamDeliverBody(ProtocolVersion version,
        const string& consumerTag,
        u_int64_t deliveryTag,
        const string& exchange,
        const string& queue
        ) : AMQRequestBody(version), 
        consumerTag(consumerTag),
        deliveryTag(deliveryTag),
        exchange(exchange),
        queue(queue)
    { }


    StreamDeliverBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~StreamDeliverBody() {}
    
    // Attribute get methods

    const string& getConsumerTag() { return consumerTag; }
    u_int64_t getDeliveryTag() { return deliveryTag; }
    const string& getExchange() { return exchange; }
    const string& getQueue() { return queue; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "StreamDeliver: ";
        out << "consumerTag=" << consumerTag;
        out << "; deliveryTag=" << deliveryTag;
        out << "; exchange=" << exchange;
        out << "; queue=" << queue;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 1 + consumerTag.length(); /* consumerTag: shortstr */
        sz += 8; /* deliveryTag: longlong */
        sz += 1 + exchange.length(); /* exchange: shortstr */
        sz += 1 + queue.length(); /* queue: shortstr */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putShortString(consumerTag); /* consumerTag: shortstr */
        buffer.putLongLong(deliveryTag); /* deliveryTag: longlong */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(queue); /* queue: shortstr */
    }

    inline void decodeContent(Buffer&  buffer)
    {
        buffer.getShortString(consumerTag); /* consumerTag: shortstr */
        deliveryTag = buffer.getLongLong(); /* deliveryTag: longlong */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(queue); /* queue: shortstr */
    }       



}; // class StreamDeliverBody


} // namespace framing
} // namespace qpid

#endif

