/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   0-9
 */

#ifndef qpid_framing_StreamQosBody__
#define qpid_framing_StreamQosBody__

#include <string>
#include <sstream>

#include "qpid/framing/amqp_types.h"
#include "qpid/framing/AMQRequestBody.h"
#include "qpid/framing/Buffer.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/FramingContent.h"

namespace qpid
{
namespace framing
{

 
class StreamQosBody : public AMQRequestBody
{

        // Method field declarations

    u_int32_t prefetchSize;
    u_int16_t prefetchCount;
    u_int32_t consumeRate;
    bool global;
     

public:
    static const ClassId CLASS_ID= 80;
    static const MethodId METHOD_ID = 10;

    typedef boost::shared_ptr<StreamQosBody> shared_ptr;

	// Constructors and destructors

    StreamQosBody(ProtocolVersion version,
        u_int32_t prefetchSize,
        u_int16_t prefetchCount,
        u_int32_t consumeRate,
        bool global
        ) : AMQRequestBody(version), 
        prefetchSize(prefetchSize),
        prefetchCount(prefetchCount),
        consumeRate(consumeRate),
        global(global)
    { }


    StreamQosBody(ProtocolVersion version): AMQRequestBody(version) {}
    virtual ~StreamQosBody() {}
    
    // Attribute get methods

    u_int32_t getPrefetchSize() { return prefetchSize; }
    u_int16_t getPrefetchCount() { return prefetchCount; }
    u_int32_t getConsumeRate() { return consumeRate; }
    bool getGlobal() { return global; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
            printPrefix(out);
            out << "StreamQos: ";
        out << "prefetchSize=" << prefetchSize;
        out << "; prefetchCount=" << prefetchCount;
        out << "; consumeRate=" << consumeRate;
        out << "; global=" << global;
    }

    inline ClassId amqpClassId() const { return CLASS_ID; }
    inline MethodId amqpMethodId() const { return METHOD_ID; }

    u_int32_t size() const
    {
        u_int32_t sz = baseSize();
        sz += 4; /* prefetchSize: long */
        sz += 2; /* prefetchCount: short */
        sz += 4; /* consumeRate: long */
        sz += 1; /* global: bit */
        return sz;
    }

    void encodeContent(Buffer&  buffer) const
    {
        buffer.putLong(prefetchSize); /* prefetchSize: long */
        buffer.putShort(prefetchCount); /* prefetchCount: short */
        buffer.putLong(consumeRate); /* consumeRate: long */
        u_int8_t flags_3[1] = {0};
        flags_3[0] |= global << 0; /* global: bit */
        buffer.putOctet(flags_3[0]);
    }

    inline void decodeContent(Buffer&  buffer)
    {
        prefetchSize = buffer.getLong(); /* prefetchSize: long */
        prefetchCount = buffer.getShort(); /* prefetchCount: short */
        consumeRate = buffer.getLong(); /* consumeRate: long */
        u_int8_t flags_3[1];
        flags_3[0] = buffer.getOctet();
        global = (1 << 0) & flags_3[0]; /* global: bit */
    }       

    void invoke(AMQP_ServerOperations& target, const MethodContext& context)
    {
        target.getStreamHandler()->qos(context,
                    prefetchSize,
                    prefetchCount,
                    consumeRate,
                    global
                    );
    }


}; // class StreamQosBody


} // namespace framing
} // namespace qpid

#endif

